//PDSLOAD  JOB (1),'RELOAD ISAMVSAM',CLASS=A,MSGCLASS=X
//*
//PDSLOAD EXEC PGM=PDSLOAD,PARM='NEW'
//SYSPRINT  DD SYSOUT=*
//SYSUT2    DD DSN=JAY01.ISAM.COBOL,       <<-- TARGET
//             DISP=(,CATLG,DELETE),UNIT=SYSDA,VOL=SER=PUB000,
//             SPACE=(TRK,(15,,10),RLSE),
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=23440)
//SYSIN     DD DATA,DLM='><'
./ ADD NAME=$INDEX   0122-21348-21356-2333-00040-00005-00000-JAY01   10
$INDEX   - This member
ISLOAD   - COBOL source to load native ISAM dataset
ISREPT1  - COBOL source to read ISAM dataset (primary key) and report
ISREPT2  - COBOL source to read ISAM dataset (primary key) and report
ISUPDT   - COBOL source to process random updates to ISAM dataset
JCOBUCL1 - JCL to compile ISLOAD+SORTNAME into ISLOAD load module
JCOBUCL2 - JCL to compile ISREPT1 into ISREPT1 load module
JCOBUCL3 - JCL to compile ISREPT2 into ISREPT2 load module
JCOBUCL4 - JCL to compile ISUPDT+SORTNAME+Y2KGTOA into ISUPDT
           load module
JCOBUCL5 - JCL to compile VSLOAD+SORTNAME+VSAMIO into VSLOAD
           load module
JCOBUCL6 - JCL to compile VSREPT+VSAMIO into VSREPT load module
JCOBUCL7 - JCL to compile VSUPDT+SORTNAME+Y2KGTOA+VSAMIO into VSUPDT
           load module
JIEBISL  - JCL to reload ISAM dataset from backup, purging deleted recs
JIEBISL2 - JCL to reload ISAM dataset from backup,
           purging deleted recs (IVI)
JIEBISU  - JCL to unload ISAM dataset to a sequential backup dataset
JIEBISU2 - JCL to unload ISAM dataset to a sequential backup
           dataset (IVI)
JISLOAD1 - JCL to execute ISLOAD to load native ISAM dataset
JISLOAD2 - JCL to execute ISLOAD to load ISAM dataset (IVI)
JISREPT1 - JCL to execute ISREPT1 to print primary key report (native)
JISREPT2 - JCL to execute ISREPT2 to print alternate key report (native)
JISREPT3 - JCL to execute ISREPT1 to print primary key report (IVI)
JISREPT4 - JCL to execute ISREPT2 to print alternate key report (IVI)
JISUPDT1 - JCL to execute ISUPDT to update ISAM dataset (native)
JISUPDT2 - JCL to execute ISUPDT to update ISAM dataset (IVI)
JVSLOAD  - JCL to execute VSLOAD to load VSAM dataset
JVSRELOD - JCL to delete and redefine VSAM dataset, then rebuild
           contents from sequential dataset backup
JVSREPT1 - JCL to execute VSREPT to print primary key report
JVSREPT2 - JCL to execute VSREPT to print alternate key report
JVSUNLOD - JCL to copy VSAM dataset to backup sequential dataset
JVSUPDT  - JCL to execute VSUPDT to update VSAM dataset
SORTNAME - COBOL source for subroutine to create sort name field
VSLOAD   - COBOL source to load VSAM dataset
VSREPT   - COBOL source to read VSAM dataset and report
VSUPDT   - COBOL source to process random updates to VSAM dataset
./ ADD NAME=ISLOAD   0117-21347-21356-1235-00148-00063-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. ISLOAD.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS DATA RECORDS FROM SEQUENTIAL DATASET (TAPE) AND LOADS
000700          ISAM DATASET.
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER. IBM-370.
001200 OBJECT-COMPUTER. IBM-370.
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500*
001600     SELECT SEQUENTIAL-FILE
001700         ASSIGN TO UT-S-SYSUT1.
001800*
001900     SELECT ISAM-MASTER
002000         ASSIGN TO DA-I-MASTER
002100         ACCESS IS SEQUENTIAL
002200         RECORD KEY IS MR-ID.
002300*
002400 DATA DIVISION.
002500 FILE SECTION.
002600*
002700 FD  SEQUENTIAL-FILE
002800     LABEL RECORDS ARE STANDARD
002900     BLOCK CONTAINS 0 RECORDS
003000     DATA RECORD IS SEQUENTIAL-RECD.
003100 01  SEQUENTIAL-RECD.
003200     02  SR-ID                   PIC 9(7).
003300     02  FILLER                  PIC X.
003400     02  SR-FIRST-NAME           PIC X(15).
003500     02  FILLER                  PIC X.
003600     02  SR-INITIAL              PIC X.
003700     02  FILLER                  PIC X.
003800     02  SR-LAST-NAME            PIC X(20).
003900     02  FILLER                  PIC X.
004000     02  SR-STREET               PIC X(35).
004100     02  FILLER                  PIC X.
004200     02  SR-CITY-STATE-ZIP       PIC X(35).
004300     02  FILLER                  PIC X.
004400     02  SR-GENDER-CODE          PIC X.
004500     02  FILLER                  PIC X.
004600     02  SR-TELEPHONE            PIC X(10).
004700     02  FILLER                  PIC X.
004800     02  SR-DATE-1               PIC X(8).
004900     02  FILLER                  PIC X.
005000     02  SR-DATE-2               PIC X(8).
005100     02  FILLER                  PIC X.
005200     02  SR-DATE-3               PIC X(8).
005300     02  FILLER                  PIC X(2).
005400*
005500 FD  ISAM-MASTER
005600     LABEL RECORDS ARE STANDARD
005700     BLOCK CONTAINS 0 RECORDS
005800     DATA RECORD IS MASTER-RECD.
005900 01  MASTER-RECD.
006000     02  MR-DELETE-CODE          PIC X.
006100     02  MR-ID                   PIC 9(7).
006200     02  MR-FIRST-NAME           PIC X(15).
006300     02  MR-INITIAL              PIC X.
006400     02  MR-LAST-NAME            PIC X(20).
006500     02  MR-STREET               PIC X(35).
006600     02  MR-CITY-STATE-ZIP       PIC X(35).
006700     02  MR-GENDER-CODE          PIC X.
006800     02  MR-TELEPHONE            PIC X(10).
006900     02  MR-DATE-1               PIC X(8).
007000     02  MR-DATE-2               PIC X(8).
007100     02  MR-DATE-3               PIC X(8).
007200     02  MR-SORT-NAME            PIC X(36).
007300     02  FILLER                  PIC X(15).
007400*
007500 WORKING-STORAGE SECTION.
007600 01  SEQUENTIAL-FILE-END-SWITCH  PIC X VALUE 'N'.
007700     88  SEQUENTIAL-FILE-END           VALUE 'Y'.
007800 01  BAD-WRITE-SWITCH            PIC X.
007900     88  BAD-ISAM-WRITE                VALUE 'Y'.
008000 01  RECORD-COUNTERS             USAGE IS COMP-3.
008100     02  INPUT-RECORD-COUNT      PIC S9(5) VALUE +0.
008200     02  OUTPUT-RECORD-COUNT     PIC S9(5) VALUE +0.
008300 01  COUNTER-EDIT                PIC ZZ,ZZ9.
008400*
008500 PROCEDURE DIVISION.
008600*
008700 OPEN-FILES.
008800*
008900     OPEN INPUT SEQUENTIAL-FILE,
009000          OUTPUT ISAM-MASTER.
009100*
009200     PERFORM PROCESS-SEQUENTIAL-FILE
009300        THRU PROCESS-SEQUENTIAL-FILE-EXIT
009400         UNTIL SEQUENTIAL-FILE-END.
009500*
009600     CLOSE SEQUENTIAL-FILE,
009700           ISAM-MASTER.
009800*
009900     MOVE INPUT-RECORD-COUNT TO COUNTER-EDIT.
010000     DISPLAY COUNTER-EDIT ' RECORDS READ FROM SEQUENTIAL FILE'.
010100     MOVE OUTPUT-RECORD-COUNT TO COUNTER-EDIT.
010200     DISPLAY COUNTER-EDIT ' RECORDS WRITTEN TO ISAM MASTER'.
010300*
010400     GOBACK.
010500*
010600 PROCESS-SEQUENTIAL-FILE.
010700*
010800     READ SEQUENTIAL-FILE
010900         AT END
011000             MOVE 'Y' TO SEQUENTIAL-FILE-END-SWITCH.
011100     IF NOT SEQUENTIAL-FILE-END
011200         ADD 1 TO INPUT-RECORD-COUNT
011300         PERFORM CREATE-ISAM-RECORD
011400            THRU CREATE-ISAM-RECORD-EXIT
011500         IF BAD-ISAM-WRITE
011600             DISPLAY 'INVALID KEY WRITING ' SR-ID
011700         ELSE
011800             ADD 1 TO OUTPUT-RECORD-COUNT.
011900*
012000 PROCESS-SEQUENTIAL-FILE-EXIT.
012100     EXIT.
012200*
012300 CREATE-ISAM-RECORD.
012400*
012500     MOVE SPACES TO MASTER-RECD.
012600     MOVE SR-ID TO MR-ID.
012700     MOVE SR-FIRST-NAME TO MR-FIRST-NAME.
012800     MOVE SR-INITIAL TO MR-INITIAL.
012900     MOVE SR-LAST-NAME TO MR-LAST-NAME.
013000     MOVE SR-STREET TO MR-STREET.
013100     MOVE SR-CITY-STATE-ZIP TO MR-CITY-STATE-ZIP.
013200     MOVE SR-GENDER-CODE TO MR-GENDER-CODE.
013300     MOVE SR-TELEPHONE TO MR-TELEPHONE.
013400     MOVE SR-DATE-1 TO MR-DATE-1.
013500     MOVE SR-DATE-2 TO MR-DATE-2.
013600     MOVE SR-DATE-3 TO MR-DATE-3.
013700     CALL 'SORTNAME' USING SR-FIRST-NAME, SR-LAST-NAME,
013800                           SR-INITIAL, MR-SORT-NAME.
013900*
014000     MOVE 'N' TO BAD-WRITE-SWITCH.
014100     WRITE MASTER-RECD
014200         INVALID KEY
014300             MOVE 'Y' TO BAD-WRITE-SWITCH.
014400
014500 CREATE-ISAM-RECORD-EXIT.
014600     EXIT.
014700*
014800* END OF PROGRAM ISLOAD.
./ ADD NAME=ISREPT1  0111-21348-21355-1718-00187-00146-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. ISREPT1.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS DATA RECORDS FROM ISAM DATASET AND PRODUCES A SIMPLE
000700          REPORT IN PRIMARY KEY SEQUENCE.
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER. IBM-370.
001200 OBJECT-COMPUTER. IBM-370.
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500*
001600     SELECT ISAM-MASTER
001700         ASSIGN TO DA-I-MASTER
001800         ACCESS IS SEQUENTIAL
001900         RECORD KEY IS MR-ID.
002000*
002100     SELECT REPORT-FILE
002200         ASSIGN TO UR-S-REPORT.
002300*
002400 DATA DIVISION.
002500 FILE SECTION.
002600*
002700 FD  ISAM-MASTER
002800     LABEL RECORDS ARE STANDARD
002900     BLOCK CONTAINS 0 RECORDS
003000     DATA RECORD IS MASTER-RECD.
003100 01  MASTER-RECD.
003200     02  MR-DELETE-CODE          PIC X.
003300     02  MR-ID                   PIC 9(7).
003400     02  MR-FIRST-NAME           PIC X(15).
003500     02  MR-INITIAL              PIC X.
003600     02  MR-LAST-NAME            PIC X(20).
003700     02  MR-STREET               PIC X(35).
003800     02  MR-CITY-STATE-ZIP       PIC X(35).
003900     02  MR-GENDER-CODE          PIC X.
004000     02  MR-TELEPHONE            PIC X(10).
004100     02  FILLER                  REDEFINES MR-TELEPHONE.
004200         03  MR-TELEPHONE-A      PIC 9(3).
004300         03  MR-TELEPHONE-P      PIC 9(3).
004400         03  MR-TELEPHONE-N      PIC 9(4).
004500     02  MR-DATE-1               PIC X(8).
004600     02  FILLER                  REDEFINES MR-DATE-1.
004700         03  MR-DATE-1M          PIC 9(2).
004800         03  MR-DATE-1D          PIC 9(2).
004900         03  MR-DATE-1Y          PIC 9(4).
005000     02  MR-DATE-2               PIC X(8).
005100     02  FILLER                  REDEFINES MR-DATE-2.
005200         03  MR-DATE-2M          PIC 9(2).
005300         03  MR-DATE-2D          PIC 9(2).
005400         03  MR-DATE-2Y          PIC 9(4).
005500     02  MR-DATE-3               PIC X(8).
005600     02  FILLER                  REDEFINES MR-DATE-3.
005700         03  MR-DATE-3M          PIC 9(2).
005800         03  MR-DATE-3D          PIC 9(2).
005900         03  MR-DATE-3Y          PIC 9(4).
006000     02  MR-SORT-NAME            PIC X(36).
006100     02  FILLER                  PIC X(15).
006200*
006300 FD  REPORT-FILE
006400     LABEL RECORDS ARE OMITTED
006500     BLOCK CONTAINS 0 RECORDS
006600     REPORT IS PRIMARY-KEY-REPORT.
006700*
006800 WORKING-STORAGE SECTION.
006900 01  ISAM-FILE-END-SWITCH        PIC X VALUE 'N'.
007000     88  ISAM-FILE-END                 VALUE 'Y'.
007100 01  RECORD-COUNTERS             USAGE IS COMP-3.
007200     02  INPUT-RECORD-COUNT      PIC S9(5) VALUE +0.
007300*
007400 REPORT SECTION.
007500 RD  PRIMARY-KEY-REPORT
007600     CONTROLS IS FINAL
007700     PAGE LIMIT IS 60 LINES
007800     FIRST DETAIL 3
007900     LAST DETAIL 55.
008000*
008100 01  HEADING-ON-PAGE             TYPE IS PAGE HEADING.
008200     02  LINE 1.
008300*
008400 01  RECORD-DETAIL               TYPE IS DETAIL.
008500     02  LINE PLUS 1.
008600         03  COLUMN 01           PIC X
008700                                 SOURCE IS MR-DELETE-CODE.
008800         03  COLUMN 03           PIC 9(7)
008900                                 SOURCE IS MR-ID.
009000         03  COLUMN 11           PIC X(15)
009100                                 SOURCE IS MR-FIRST-NAME.
009200         03  COLUMN 27           PIC X
009300                                 SOURCE IS MR-INITIAL.
009400         03  COLUMN 29           PIC X(20)
009500                                 SOURCE IS MR-LAST-NAME.
009600         03  COLUMN 50           PIC X(35)
009700                                 SOURCE IS MR-STREET.
009800         03  COLUMN 86           PIC X
009900                                 SOURCE IS MR-GENDER-CODE.
010000         03  COLUMN 88           PIC X
010100                                 VALUE '('.
010200         03  COLUMN 89           PIC 9(3)
010300                                 SOURCE IS MR-TELEPHONE-A.
010400         03  COLUMN 92           PIC X
010500                                 VALUE ')'.
010600         03  COLUMN 93           PIC 9(3)
010700                                 SOURCE IS MR-TELEPHONE-P.
010800         03  COLUMN 96           PIC X
010900                                 VALUE '-'.
011000         03  COLUMN 97           PIC 9(4)
011100                                 SOURCE IS MR-TELEPHONE-N.
011200         03  COLUMN 102          PIC 9(2)
011300                                 SOURCE IS MR-DATE-1M.
011400         03  COLUMN 104          PIC X
011500                                 VALUE '/'.
011600         03  COLUMN 105          PIC 9(2)
011700                                 SOURCE IS MR-DATE-1D.
011800         03  COLUMN 107          PIC X
011900                                 VALUE '/'.
012000         03  COLUMN 108          PIC 9(4)
012100                                 SOURCE IS MR-DATE-1Y.
012200         03  COLUMN 113          PIC 9(2)
012300                                 SOURCE IS MR-DATE-2M.
012400         03  COLUMN 115          PIC X
012500                                 VALUE '/'.
012600         03  COLUMN 116          PIC 9(2)
012700                                 SOURCE IS MR-DATE-2D.
012800         03  COLUMN 118          PIC X
012900                                 VALUE '/'.
013000         03  COLUMN 119          PIC 9(4)
013100                                 SOURCE IS MR-DATE-2Y.
013200     02  LINE PLUS 1.
013300         03  COLUMN 11           PIC X(36)
013400                                 SOURCE IS MR-SORT-NAME.
013500         03  COLUMN 50           PIC X(35)
013600                                 SOURCE IS MR-CITY-STATE-ZIP.
013700         03  COLUMN 102          PIC 9(2)
013800                                 SOURCE IS MR-DATE-3M.
013900         03  COLUMN 104          PIC X
014000                                 VALUE '/'.
014100         03  COLUMN 105          PIC 9(2)
014200                                 SOURCE IS MR-DATE-3D.
014300         03  COLUMN 107          PIC X
014400                                 VALUE '/'.
014500         03  COLUMN 108          PIC 9(4)
014600                                 SOURCE IS MR-DATE-3Y.
014700     02  LINE PLUS 1.
014800*
014900 01  REPORT-FOOTING              TYPE IS CONTROL FOOTING FINAL.
015000     02  LINE NEXT PAGE.
015100         03  COLUMN 01           PIC ZZ,ZZ9
015200                                 SOURCE IS INPUT-RECORD-COUNT.
015300         03  COLUMN 08           PIC X(22)
015400                                 VALUE 'RECORDS READ FROM FILE'.
015500*
015600 PROCEDURE DIVISION.
015700*
015800 OPEN-FILES.
015900*
016000     OPEN INPUT ISAM-MASTER,
016100          OUTPUT REPORT-FILE.
016200*
016300     INITIATE PRIMARY-KEY-REPORT.
016400     PERFORM PROCESS-ISAM-MASTER
016500        THRU PROCESS-ISAM-MASTER-EXIT
016600         UNTIL ISAM-FILE-END.
016700     TERMINATE PRIMARY-KEY-REPORT.
016800*
016900     CLOSE ISAM-MASTER,
017000           REPORT-FILE.
017100*
017200     GOBACK.
017300*
017400 PROCESS-ISAM-MASTER.
017500*
017600     READ ISAM-MASTER
017700         AT END
017800             MOVE 'Y' TO ISAM-FILE-END-SWITCH.
017900     IF NOT ISAM-FILE-END
018000         ADD 1 TO INPUT-RECORD-COUNT
018100         GENERATE RECORD-DETAIL
018200     .
018300*
018400 PROCESS-ISAM-MASTER-EXIT.
018500     EXIT.
018600*
018700* END OF PROGRAM ISREPT1.
./ ADD NAME=ISREPT2  0112-21348-21355-1719-00260-00186-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. ISREPT2.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS DATA RECORDS FROM ISAM DATASET AND PRODUCES A SIMPLE
000700          REPORT IN AN ALTERNATE SEQUENCE.
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER. IBM-370.
001200 OBJECT-COMPUTER. IBM-370.
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500*
001600     SELECT ISAM-MASTER
001700         ASSIGN TO DA-I-MASTER
001800         ACCESS IS SEQUENTIAL
001900         RECORD KEY IS MR-ID.
002000*
002100     SELECT SORT-FILE
002200         ASSIGN TO DA-S-SORTFILE.
002300*
002400     SELECT REPORT-FILE
002500         ASSIGN TO UR-S-REPORT.
002600*
002700 DATA DIVISION.
002800 FILE SECTION.
002900*
003000 FD  ISAM-MASTER
003100     LABEL RECORDS ARE STANDARD
003200     BLOCK CONTAINS 0 RECORDS
003300     DATA RECORD IS MASTER-RECD.
003400 01  MASTER-RECD.
003500     02  MR-DELETE-CODE          PIC X.
003600     02  MR-ID                   PIC 9(7).
003700     02  MR-FIRST-NAME           PIC X(15).
003800     02  MR-INITIAL              PIC X.
003900     02  MR-LAST-NAME            PIC X(20).
004000     02  MR-STREET               PIC X(35).
004100     02  MR-CITY-STATE-ZIP       PIC X(35).
004200     02  MR-GENDER-CODE          PIC X.
004300     02  MR-TELEPHONE            PIC X(10).
004400     02  FILLER                  REDEFINES MR-TELEPHONE.
004500         03  MR-TELEPHONE-A      PIC 9(3).
004600         03  MR-TELEPHONE-P      PIC 9(3).
004700         03  MR-TELEPHONE-N      PIC 9(4).
004800     02  MR-DATE-1               PIC X(8).
004900     02  FILLER                  REDEFINES MR-DATE-1.
005000         03  MR-DATE-1M          PIC 9(2).
005100         03  MR-DATE-1D          PIC 9(2).
005200         03  MR-DATE-1Y          PIC 9(4).
005300     02  MR-DATE-2               PIC X(8).
005400     02  FILLER                  REDEFINES MR-DATE-2.
005500         03  MR-DATE-2M          PIC 9(2).
005600         03  MR-DATE-2D          PIC 9(2).
005700         03  MR-DATE-2Y          PIC 9(4).
005800     02  MR-DATE-3               PIC X(8).
005900     02  FILLER                  REDEFINES MR-DATE-3.
006000         03  MR-DATE-3M          PIC 9(2).
006100         03  MR-DATE-3D          PIC 9(2).
006200         03  MR-DATE-3Y          PIC 9(4).
006300     02  MR-SORT-NAME            PIC X(36).
006400     02  FILLER                  PIC X(15).
006500*
006600 SD  SORT-FILE
006700     RECORD CONTAINS 200 CHARACTERS
006800     DATA RECORD IS SORT-RECD.
006900 01  SORT-RECD.
007000     02  SR-DELETE-CODE          PIC X.
007100     02  SR-ID                   PIC 9(7).
007200     02  SR-FIRST-NAME           PIC X(15).
007300     02  SR-INITIAL              PIC X.
007400     02  SR-LAST-NAME            PIC X(20).
007500     02  SR-STREET               PIC X(35).
007600     02  SR-CITY-STATE-ZIP       PIC X(35).
007700     02  SR-GENDER-CODE          PIC X.
007800     02  SR-TELEPHONE            PIC X(10).
007900     02  FILLER                  REDEFINES SR-TELEPHONE.
008000         03  SR-TELEPHONE-A      PIC 9(3).
008100         03  SR-TELEPHONE-P      PIC 9(3).
008200         03  SR-TELEPHONE-N      PIC 9(4).
008300     02  SR-DATE-1               PIC X(8).
008400     02  FILLER                  REDEFINES SR-DATE-1.
008500         03  SR-DATE-1M          PIC 9(2).
008600         03  SR-DATE-1D          PIC 9(2).
008700         03  SR-DATE-1Y          PIC 9(4).
008800     02  SR-DATE-2               PIC X(8).
008900     02  FILLER                  REDEFINES SR-DATE-2.
009000         03  SR-DATE-2M          PIC 9(2).
009100         03  SR-DATE-2D          PIC 9(2).
009200         03  SR-DATE-2Y          PIC 9(4).
009300     02  SR-DATE-3               PIC X(8).
009400     02  FILLER                  REDEFINES SR-DATE-3.
009500         03  SR-DATE-3M          PIC 9(2).
009600         03  SR-DATE-3D          PIC 9(2).
009700         03  SR-DATE-3Y          PIC 9(4).
009800     02  SR-SORT-NAME            PIC X(36).
009900     02  FILLER                  PIC X(15).
010000*
010100 FD  REPORT-FILE
010200     LABEL RECORDS ARE OMITTED
010300     BLOCK CONTAINS 0 RECORDS
010400     REPORT IS ALTERNATE-KEY-REPORT.
010500*
010600 WORKING-STORAGE SECTION.
010700 01  ISAM-FILE-END-SWITCH        PIC X VALUE 'N'.
010800     88  ISAM-FILE-END                 VALUE 'Y'.
010900 01  SORT-FILE-END-SWITCH        PIC X VALUE 'N'.
011000     88  SORT-FILE-END                 VALUE 'Y'.
011100 01  RECORD-COUNTERS             USAGE IS COMP-3.
011200     02  INPUT-RECORD-COUNT      PIC S9(5) VALUE +0.
011300     02  SORTED-RECORD-COUNT     PIC S9(5) VALUE +0.
011400*
011500 REPORT SECTION.
011600 RD  ALTERNATE-KEY-REPORT
011700     CONTROLS IS FINAL
011800     PAGE LIMIT IS 60 LINES
011900     FIRST DETAIL 3
012000     LAST DETAIL 55.
012100*
012200 01  HEADING-ON-PAGE             TYPE IS PAGE HEADING.
012300     02  LINE 1.
012400*
012500 01  RECORD-DETAIL               TYPE IS DETAIL.
012600     02  LINE PLUS 1.
012700         03  COLUMN 01           PIC X
012800                                 SOURCE IS SR-DELETE-CODE.
012900         03  COLUMN 03           PIC 9(7)
013000                                 SOURCE IS SR-ID.
013100         03  COLUMN 11           PIC X(15)
013200                                 SOURCE IS SR-FIRST-NAME.
013300         03  COLUMN 27           PIC X
013400                                 SOURCE IS SR-INITIAL.
013500         03  COLUMN 29           PIC X(20)
013600                                 SOURCE IS SR-LAST-NAME.
013700         03  COLUMN 50           PIC X(35)
013800                                 SOURCE IS SR-STREET.
013900         03  COLUMN 86           PIC X
014000                                 SOURCE IS SR-GENDER-CODE.
014100         03  COLUMN 88           PIC X
014200                                 VALUE '('.
014300         03  COLUMN 89           PIC 9(3)
014400                                 SOURCE IS SR-TELEPHONE-A.
014500         03  COLUMN 92           PIC X
014600                                 VALUE ')'.
014700         03  COLUMN 93           PIC 9(3)
014800                                 SOURCE IS SR-TELEPHONE-P.
014900         03  COLUMN 96           PIC X
015000                                 VALUE '-'.
015100         03  COLUMN 97           PIC 9(4)
015200                                 SOURCE IS SR-TELEPHONE-N.
015300         03  COLUMN 102          PIC 9(2)
015400                                 SOURCE IS SR-DATE-1M.
015500         03  COLUMN 104          PIC X
015600                                 VALUE '/'.
015700         03  COLUMN 105          PIC 9(2)
015800                                 SOURCE IS SR-DATE-1D.
015900         03  COLUMN 107          PIC X
016000                                 VALUE '/'.
016100         03  COLUMN 108          PIC 9(4)
016200                                 SOURCE IS SR-DATE-1Y.
016300         03  COLUMN 113          PIC 9(2)
016400                                 SOURCE IS SR-DATE-2M.
016500         03  COLUMN 115          PIC X
016600                                 VALUE '/'.
016700         03  COLUMN 116          PIC 9(2)
016800                                 SOURCE IS SR-DATE-2D.
016900         03  COLUMN 118          PIC X
017000                                 VALUE '/'.
017100         03  COLUMN 119          PIC 9(4)
017200                                 SOURCE IS SR-DATE-2Y.
017300     02  LINE PLUS 1.
017400         03  COLUMN 11           PIC X(36)
017500                                 SOURCE IS SR-SORT-NAME.
017600         03  COLUMN 50           PIC X(35)
017700                                 SOURCE IS SR-CITY-STATE-ZIP.
017800         03  COLUMN 102          PIC 9(2)
017900                                 SOURCE IS SR-DATE-3M.
018000         03  COLUMN 104          PIC X
018100                                 VALUE '/'.
018200         03  COLUMN 105          PIC 9(2)
018300                                 SOURCE IS SR-DATE-3D.
018400         03  COLUMN 107          PIC X
018500                                 VALUE '/'.
018600         03  COLUMN 108          PIC 9(4)
018700                                 SOURCE IS SR-DATE-3Y.
018800     02  LINE PLUS 1.
018900*
019000 01  REPORT-FOOTING              TYPE IS CONTROL FOOTING FINAL.
019100     02  LINE NEXT PAGE.
019200         03  COLUMN 01           PIC ZZ,ZZ9
019300                                 SOURCE IS INPUT-RECORD-COUNT.
019400         03  COLUMN 08           PIC X(22)
019500                                 VALUE 'RECORDS READ FROM FILE'.
019600     02  LINE PLUS 1.
019700         03  COLUMN 01           PIC ZZ,ZZ9
019800                                 SOURCE IS SORTED-RECORD-COUNT.
019900         03  COLUMN 08           PIC X(26)
020000                                 VALUE
020100             'RECORDS RETURNED FROM SORT'.
020200*
020300 PROCEDURE DIVISION.
020400*
020500 MAIN-LOGIC SECTION.
020600*
020700 SORT-ISAM-MASTER.
020800*
020900     SORT SORT-FILE
021000         ON ASCENDING KEY SR-SORT-NAME
021100         INPUT PROCEDURE IS SORT-RELEASE-PROCEDURE
021200         OUTPUT PROCEDURE IS REPORT-PROCEDURE.
021300     GOBACK.
021400*
021500 READ-ISAM-MASTER.
021600*
021700     READ ISAM-MASTER
021800         AT END
021900             MOVE 'Y' TO ISAM-FILE-END-SWITCH.
022000     IF NOT ISAM-FILE-END
022100         ADD 1 TO INPUT-RECORD-COUNT
022200         RELEASE SORT-RECD FROM MASTER-RECD.
022300*
022400 READ-ISAM-MASTER-EXIT.
022500     EXIT.
022600*
022700 RETURN-SORTED-RECORD.
022800*
022900     RETURN SORT-FILE
023000         AT END
023100             MOVE 'Y' TO SORT-FILE-END-SWITCH.
023200     IF NOT SORT-FILE-END
023300         ADD 1 TO SORTED-RECORD-COUNT
023400         GENERATE RECORD-DETAIL
023500     .
023600*
023700 RETURN-SORTED-RECORD-EXIT.
023800     EXIT.
023900*
024000 SORT-RELEASE-PROCEDURE SECTION.
024100*
024200     OPEN INPUT ISAM-MASTER.
024300     PERFORM READ-ISAM-MASTER
024400        THRU READ-ISAM-MASTER-EXIT
024500         UNTIL ISAM-FILE-END.
024600     CLOSE ISAM-MASTER.
024700*
024800 REPORT-PROCEDURE SECTION.
024900*
025000     OPEN OUTPUT REPORT-FILE.
025100*
025200     INITIATE ALTERNATE-KEY-REPORT.
025300     PERFORM RETURN-SORTED-RECORD
025400        THRU RETURN-SORTED-RECORD-EXIT
025500         UNTIL SORT-FILE-END.
025600     TERMINATE ALTERNATE-KEY-REPORT.
025700*
025800     CLOSE REPORT-FILE.
025900*
026000* END OF PROGRAM ISREPT2.
./ ADD NAME=ISUPDT   0114-21348-21355-0929-00774-00355-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. ISUPDT.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS UPDATE INFORMATION FROM SEQUENTIAL DATASET AND UPDATES
000700          ISAM DATASET, WHICH IS ACCESSED RANDOMLY. UPDATES PROCESSED
000800          INCLUDE SETTING DELETE CODE, CHANGING FIELD VALUES OF EXISTING
000900          RECORDS, AND ADDING NEW RECORDS.
001000*
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER. IBM-370.
001400 OBJECT-COMPUTER. IBM-370.
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800     SELECT UPDATE-FILE
001900         ASSIGN TO UT-S-SYSUT1.
002000*
002100     SELECT ISAM-MASTER
002200         ASSIGN TO DA-I-MASTER
002300         ACCESS IS RANDOM
002400         RECORD KEY IS MR-ID
002500         NOMINAL KEY IS WS-NOMINAL-ID.
002600*
002700     SELECT REPORT-FILE
002800         ASSIGN TO UR-S-REPORT.
002900*
003000 DATA DIVISION.
003100 FILE SECTION.
003200*
003300 FD  UPDATE-FILE
003400     LABEL RECORDS ARE STANDARD
003500     BLOCK CONTAINS 0 RECORDS
003600     RECORD CONTAINS 80 CHARACTERS
003700     DATA RECORD IS UPDATE-RECD.
003800 01  UPDATE-RECD.
003900     02  UPDATE-KEY.
004000         03  UPDATE-ID           PIC X(7).
004100         03  UPDATE-ACTION       PIC X.
004200             88  ACTION-IS-VALID          VALUE 'U' 'A' 'D'.
004300     02  UPDATE-FIELD            PIC X(2).
004400         88  VALID-UPDATE-FIELD           VALUE '01' '02' '03'
004500                                                '04' '05' '06'
004600                                                '07' '08' '09'
004700                                                '10'.
004800         88  UPDATE-FIELD-FIRST-NAME      VALUE '01'.
004900         88  UPDATE-FIELD-INITIAL         VALUE '02'.
005000         88  UPDATE-FIELD-LAST-NAME       VALUE '03'.
005100         88  UPDATE-FIELD-STREET          VALUE '04'.
005200         88  UPDATE-FIELD-CITY            VALUE '05'.
005300         88  UPDATE-FIELD-GENDER          VALUE '06'.
005400         88  UPDATE-FIELD-PHONE           VALUE '07'.
005500         88  UPDATE-FIELD-DATE1           VALUE '08'.
005600         88  UPDATE-FIELD-DATE2           VALUE '09'.
005700         88  UPDATE-FIELD-DATE3           VALUE '10'.
005800     02  UPDATE-DATA                      PIC X(70).
005900     02  UPDATA-DATA-01                   REDEFINES UPDATE-DATA.
006000         03  UPDATE-DATA-FIRST-NAME       PIC X(15).
006100         03  FILLER                       PIC X(55).
006200     02  UPDATA-DATA-02                   REDEFINES UPDATE-DATA.
006300         03  UPDATE-DATA-INITIAL          PIC X.
006400         03  FILLER                       PIC X(69).
006500     02  UPDATA-DATA-03                   REDEFINES UPDATE-DATA.
006600         03  UPDATE-DATA-LAST-NAME        PIC X(20).
006700         03  FILLER                       PIC X(50).
006800     02  UPDATA-DATA-04                   REDEFINES UPDATE-DATA.
006900         03  UPDATE-DATA-STREET           PIC X(35).
007000         03  FILLER                       PIC X(35).
007100     02  UPDATA-DATA-05                   REDEFINES UPDATE-DATA.
007200         03  UPDATE-DATA-CITY             PIC X(35).
007300         03  FILLER                       PIC X(35).
007400     02  UPDATA-DATA-06                   REDEFINES UPDATE-DATA.
007500         03  UPDATE-DATA-GENDER           PIC X.
007600         03  FILLER                       PIC X(69).
007700     02  UPDATA-DATA-07                   REDEFINES UPDATE-DATA.
007800         03  UPDATE-DATA-PHONE            PIC X(10).
007900         03  FILLER                       PIC X(60).
008000     02  UPDATA-DATA-08-10                REDEFINES UPDATE-DATA.
008100         03  UPDATE-DATA-DATE             PIC X(8).
008200         03  FILLER                       PIC X(62).
008300*
008400 FD  ISAM-MASTER
008500     LABEL RECORDS ARE STANDARD
008600     RECORD CONTAINS 200 CHARACTERS
008700     DATA RECORD IS MASTER-RECD.
008800 01  MASTER-RECD.
008900     02  MR-DELETE-CODE          PIC X.
009000     02  MR-ID                   PIC 9(7).
009100     02  MR-FIRST-NAME           PIC X(15).
009200     02  MR-INITIAL              PIC X.
009300     02  MR-LAST-NAME            PIC X(20).
009400     02  MR-STREET               PIC X(35).
009500     02  MR-CITY-STATE-ZIP       PIC X(35).
009600     02  MR-GENDER-CODE          PIC X.
009700     02  MR-TELEPHONE            PIC X(10).
009800     02  FILLER                  REDEFINES MR-TELEPHONE.
009900         03  MR-TELEPHONE-A      PIC 9(3).
010000         03  MR-TELEPHONE-P      PIC 9(3).
010100         03  MR-TELEPHONE-N      PIC 9(4).
010200     02  MR-DATE-1               PIC X(8).
010300     02  FILLER                  REDEFINES MR-DATE-1.
010400         03  MR-DATE-1M          PIC 9(2).
010500         03  MR-DATE-1D          PIC 9(2).
010600         03  MR-DATE-1Y          PIC 9(4).
010700     02  MR-DATE-2               PIC X(8).
010800     02  FILLER                  REDEFINES MR-DATE-2.
010900         03  MR-DATE-2M          PIC 9(2).
011000         03  MR-DATE-2D          PIC 9(2).
011100         03  MR-DATE-2Y          PIC 9(4).
011200     02  MR-DATE-3               PIC X(8).
011300     02  FILLER                  REDEFINES MR-DATE-3.
011400         03  MR-DATE-3M          PIC 9(2).
011500         03  MR-DATE-3D          PIC 9(2).
011600         03  MR-DATE-3Y          PIC 9(4).
011700     02  MR-SORT-NAME            PIC X(36).
011800     02  FILLER                  PIC X(15).
011900*
012000 FD  REPORT-FILE
012100     LABEL RECORDS ARE OMITTED
012200     REPORT IS UPDATE-REPORT.
012300*
012400 WORKING-STORAGE SECTION.
012500 01  SWITCHES-FOR-TESTS.
012600     02  UPDATE-FILE-END-SWITCH  PIC X VALUE 'N'.
012700         88  UPDATE-FILE-END           VALUE 'Y'.
012800     02  UPDATE-RECORD-VALID-SW  PIC X VALUE 'N'.
012900         88  UPDATE-RECD-VALID         VALUE 'Y'.
013000     02  READ-INVALID-KEY-SW     PIC X VALUE 'N'.
013100         88  READ-INVALID-KEY          VALUE 'Y'.
013200     02  REWRITE-INVALID-KEY-SW  PIC X VALUE 'N'.
013300         88  REWRITE-INVALID-KEY       VALUE 'Y'.
013400     02  WRITE-INVALID-KEY-SW    PIC X VALUE 'N'.
013500         88  WRITE-INVALID-KEY         VALUE 'Y'.
013600*
013700 01  WS-NOMINAL-ID               PIC X(7).
013800*
013900 01  WS-ORIGINAL-DELETE-CODE     PIC X.
014000*
014100 01  DELETE-FLAG-INIT            PIC S9(4) COMP VALUE +255.
014200 01  FILLER                      REDEFINES DELETE-FLAG-INIT.
014300     02  FILLER                  PIC X.
014400     02  DELETE-FLAG-BYTE        PIC X.
014500*
014600 01  RECORD-COUNTERS             USAGE IS COMP-3.
014700     02  UPDATE-RECORD-COUNT     PIC S9(5) VALUE +0.
014800     02  ERRONEOUS-UPDATE-COUNT  PIC S9(5) VALUE +0.
014900     02  CHANGED-RECORD-COUNT    PIC S9(5) VALUE +0.
015000     02  DELETED-RECORD-COUNT    PIC S9(5) VALUE +0.
015100     02  ADDED-RECORD-COUNT      PIC S9(5) VALUE +0.
015200     02  UNMATCHED-CHANGE-COUNT  PIC S9(5) VALUE +0.
015300     02  DUPLICATE-ADD-COUNT     PIC S9(5) VALUE +0.
015400*
015500 01  WS-UPDATE-RECORD            VALUE LOW-VALUES.
015600     02  WSUR-KEY.
015700         03  WSUR-ID             PIC X(7).
015800         03  WSUR-ACTION         PIC X.
015900             88  ACTION-IS-CHANGE         VALUE 'U'.
016000             88  ACTION-IS-ADD            VALUE 'A'.
016100             88  ACTION-IS-DELETE         VALUE 'D'.
016200     02  WSUR-FIRST-NAME         PIC X(15).
016300     02  WSUR-INITIAL            PIC X.
016400     02  WSUR-LAST-NAME          PIC X(20).
016500     02  WSUR-STREET             PIC X(35).
016600     02  WSUR-CITY               PIC X(35).
016700     02  WSUR-GENDER             PIC X.
016800     02  WSUR-PHONE              PIC X(10).
016900     02  WSUR-DATE1              PIC X(8).
017000     02  WSUR-DATE2              PIC X(8).
017100     02  WSUR-DATE3              PIC X(8).
017200*
017300 01  ERROR-MESSAGES.
017400     02  FILLER                  PIC X(50) VALUE
017500         'RECORD ID TO UPDATE NOT NUMERIC'.
017600     02  FILLER                  PIC X(50) VALUE
017700         'UPDATE ACTION NOT VALID (U/A/D)'.
017800     02  FILLER                  PIC X(50) VALUE
017900         'UPDATE FIELD NUMBER NOT VALID (01-10)'.
018000     02  FILLER                  PIC X(50) VALUE
018100         'FIRST NAME MAY NOT BE SPACES'.
018200     02  FILLER                  PIC X(50) VALUE
018300         'LAST NAME MAY NOT BE SPACES'.
018400     02  FILLER                  PIC X(50) VALUE
018500         'STREET MAY NOT BE SPACES'.
018600     02  FILLER                  PIC X(50) VALUE
018700         'CITY, STATE, ZIP MAY NOT BE SPACES'.
018800     02  FILLER                  PIC X(50) VALUE
018900         'GENDER CODE MUST BE "F" OR "M"'.
019000     02  FILLER                  PIC X(50) VALUE
019100         'TELEPHONE NUMBER MUST BE NUMERIC'.
019200     02  FILLER                  PIC X(50) VALUE
019300         'DATE FIELD CONTAINS INVALID CHARACTER'.
019400     02  FILLER                  PIC X(50) VALUE
019500         'YEAR IS NOT VALID FOR DATE'.
019600     02  FILLER                  PIC X(50) VALUE
019700         'MONTH IS NOT VALID FOR DATE'.
019800     02  FILLER                  PIC X(50) VALUE
019900         'DAY IS NOT VALID FOR DATE'.
020000     02  FILLER                  PIC X(50) VALUE
020100         'MASTER RECORD ALREADY EXISTS FOR ADD'.
020200     02  FILLER                  PIC X(50) VALUE
020300         'MASTER RECORD NOT FOUND FOR CHANGE/DELETE'.
020400     02  FILLER                  PIC X(50) VALUE
020500         'INVALID KEY ON REWRITE'.
020600     02  FILLER                  PIC X(50) VALUE
020700         'INVALID KEY ON WRITE'.
020800 01  ERROR-MESSAGE-TABLE         REDEFINES ERROR-MESSAGES.
020900     02  ERROR-MESSAGE-TEXT      OCCURS 17 TIMES
021000                                 INDEXED BY EMX
021100                                 PIC X(50).
021200*
021300 01  DETAIL-TYPES.
021400     02  FILLER                  PIC X(9) VALUE '-BEFORE- '.
021500     02  FILLER                  PIC X(9) VALUE '-AFTER-  '.
021600     02  FILLER                  PIC X(9) VALUE '-ADDED-  '.
021700     02  FILLER                  PIC X(9) VALUE '-DELETED-'.
021800 01  DETAIL-TYPES-TABLE          REDEFINES DETAIL-TYPES.
021900     02  DETAIL-TYPE             OCCURS 4 TIMES
022000                                 INDEXED BY DTX
022100                                 PIC X(9).
022200*
022300 01  GTOA-PARAMETERS.
022400     02   GTOAP-DATE-G           PIC X(8).
022500     02   GTOAP-RETURN-CODE      PIC 9(1).
022600     02   GTOAP-ANUM             PIC S9(7).
022700     02   FILLER                 PIC X(26).
022800*
022900 REPORT SECTION.
023000 RD  UPDATE-REPORT
023100     CONTROLS IS FINAL
023200     PAGE LIMIT IS 60 LINES
023300     FIRST DETAIL 3
023400     LAST DETAIL 55.
023500*
023600 01  HEADING-ON-PAGE             TYPE IS PAGE HEADING.
023700     02  LINE 1.
023800*
023900 01  VALIDATE-ERROR-DETAIL       TYPE IS DETAIL.
024000     02  LINE PLUS 1.
024100         03  COLUMN 01           PIC X(60)
024200                                 SOURCE IS UPDATE-RECD.
024300         03  COLUMN 50           PIC X(50)
024400                                 SOURCE IS
024500             ERROR-MESSAGE-TEXT (EMX).
024600     02  LINE PLUS 1.
024700*
024800 01  RECORD-FIELDS-DETAIL        TYPE IS DETAIL.
024900     02  LINE PLUS 1.
025000         03  COLUMN 01           PIC X
025100                                 SOURCE IS MR-DELETE-CODE.
025200         03  COLUMN 03           PIC 9(7)
025300                                 SOURCE IS MR-ID.
025400         03  COLUMN 11           PIC X(15)
025500                                 SOURCE IS MR-FIRST-NAME.
025600         03  COLUMN 27           PIC X
025700                                 SOURCE IS MR-INITIAL.
025800         03  COLUMN 29           PIC X(20)
025900                                 SOURCE IS MR-LAST-NAME.
026000         03  COLUMN 50           PIC X(35)
026100                                 SOURCE IS MR-STREET.
026200         03  COLUMN 86           PIC X
026300                                 SOURCE IS MR-GENDER-CODE.
026400         03  COLUMN 88           PIC X
026500                                 VALUE '('.
026600         03  COLUMN 89           PIC 9(3)
026700                                 SOURCE IS MR-TELEPHONE-A.
026800         03  COLUMN 92           PIC X
026900                                 VALUE ')'.
027000         03  COLUMN 93           PIC 9(3)
027100                                 SOURCE IS MR-TELEPHONE-P.
027200         03  COLUMN 96           PIC X
027300                                 VALUE '-'.
027400         03  COLUMN 97           PIC 9(4)
027500                                 SOURCE IS MR-TELEPHONE-N.
027600         03  COLUMN 102          PIC 9(2)
027700                                 SOURCE IS MR-DATE-1M.
027800         03  COLUMN 104          PIC X
027900                                 VALUE '/'.
028000         03  COLUMN 105          PIC 9(2)
028100                                 SOURCE IS MR-DATE-1D.
028200         03  COLUMN 107          PIC X
028300                                 VALUE '/'.
028400         03  COLUMN 108          PIC 9(4)
028500                                 SOURCE IS MR-DATE-1Y.
028600         03  COLUMN 113          PIC 9(2)
028700                                 SOURCE IS MR-DATE-2M.
028800         03  COLUMN 115          PIC X
028900                                 VALUE '/'.
029000         03  COLUMN 116          PIC 9(2)
029100                                 SOURCE IS MR-DATE-2D.
029200         03  COLUMN 118          PIC X
029300                                 VALUE '/'.
029400         03  COLUMN 119          PIC 9(4)
029500                                 SOURCE IS MR-DATE-2Y.
029600         03  COLUMN 124          PIC X(9)
029700                                 SOURCE IS DETAIL-TYPE (DTX).
029800     02  LINE PLUS 1.
029900         03  COLUMN 11           PIC X(36)
030000                                 SOURCE IS MR-SORT-NAME.
030100         03  COLUMN 50           PIC X(35)
030200                                 SOURCE IS MR-CITY-STATE-ZIP.
030300         03  COLUMN 102          PIC 9(2)
030400                                 SOURCE IS MR-DATE-3M.
030500         03  COLUMN 104          PIC X
030600                                 VALUE '/'.
030700         03  COLUMN 105          PIC 9(2)
030800                                 SOURCE IS MR-DATE-3D.
030900         03  COLUMN 107          PIC X
031000                                 VALUE '/'.
031100         03  COLUMN 108          PIC 9(4)
031200                                 SOURCE IS MR-DATE-3Y.
031300     02  LINE PLUS 1.
031400*
031500 01  WRITE-ERROR-DETAIL          TYPE IS DETAIL.
031600     02  LINE PLUS 2.
031700         03  COLUMN 01           PIC X(7)
031800                                 SOURCE IS MR-ID.
031900         03  COLUMN 10           PIC X(50)
032000                                 SOURCE IS
032100             ERROR-MESSAGE-TEXT (EMX).
032200     02  LINE PLUS 1.
032300*
032400 01  REPORT-FOOTING              TYPE IS CONTROL FOOTING FINAL.
032500     02  LINE NEXT PAGE.
032600         03  COLUMN 01           PIC ZZ,ZZ9
032700                                 SOURCE IS UPDATE-RECORD-COUNT.
032800         03  COLUMN 08           PIC X(50)
032900                                 VALUE
033000             'UPDATE RECORDS READ'.
033100     02  LINE PLUS 1.
033200         03  COLUMN 01           PIC ZZ,ZZ9
033300                                 SOURCE IS ERRONEOUS-UPDATE-COUNT.
033400         03  COLUMN 08           PIC X(50)
033500                                 VALUE
033600             'UPDATE RECORDS WITH INVALID DATA'.
033700     02  LINE PLUS 2.
033800         03  COLUMN 01           PIC ZZ,ZZ9
033900                                 SOURCE IS CHANGED-RECORD-COUNT.
034000         03  COLUMN 08           PIC X(50)
034100                                 VALUE
034200             'MASTER RECORDS UPDATED'.
034300     02  LINE PLUS 1.
034400         03  COLUMN 01           PIC ZZ,ZZ9
034500                                 SOURCE IS DELETED-RECORD-COUNT.
034600         03  COLUMN 08           PIC X(50)
034700                                 VALUE
034800             'MASTER RECORDS DELETED'.
034900     02  LINE PLUS 1.
035000         03  COLUMN 01           PIC ZZ,ZZ9
035100                                 SOURCE IS ADDED-RECORD-COUNT.
035200         03  COLUMN 08           PIC X(50)
035300                                 VALUE
035400             'MASTER RECORDS ADDED'.
035500     02  LINE PLUS 2.
035600         03  COLUMN 01           PIC ZZ,ZZ9
035700                                 SOURCE IS UNMATCHED-CHANGE-COUNT.
035800         03  COLUMN 08           PIC X(50)
035900                                 VALUE
036000             'ATTEMPTED UPDATES/DELETES WITH NO MATCHING MASTER'.
036100     02  LINE PLUS 1.
036200         03  COLUMN 01           PIC ZZ,ZZ9
036300                                 SOURCE IS DUPLICATE-ADD-COUNT.
036400         03  COLUMN 08           PIC X(50)
036500                                 VALUE
036600             'ATTEMPTED ADDS WITH DUPLICATE MASTER'.
036700*
036800 PROCEDURE DIVISION.
036900*
037000 OPEN-FILES.
037100*
037200     OPEN INPUT UPDATE-FILE,
037300          I-O ISAM-MASTER,
037400          OUTPUT REPORT-FILE.
037500*
037600     INITIATE UPDATE-REPORT.
037700     PERFORM PROCESS-UPDATE-FILE
037800        THRU PROCESS-UPDATE-FILE-EXIT
037900         UNTIL UPDATE-FILE-END.
038000     IF WSUR-KEY NOT = LOW-VALUES
038100         PERFORM PROCESS-UPDATE-SET
038200            THRU PROCESS-UPDATE-SET-EXIT.
038300     TERMINATE UPDATE-REPORT.
038400*
038500     CLOSE UPDATE-FILE,
038600           ISAM-MASTER,
038700           REPORT-FILE.
038800*
038900     GOBACK.
039000*
039100 PROCESS-UPDATE-FILE.
039200*
039300     READ UPDATE-FILE
039400         AT END
039500             MOVE 'Y' TO UPDATE-FILE-END-SWITCH
039600     .
039700     IF NOT UPDATE-FILE-END
039800         ADD 1 TO UPDATE-RECORD-COUNT
039900         PERFORM PROCESS-UPDATE-RECORD
040000            THRU PROCESS-UPDATE-RECORD-EXIT
040100     .
040200*
040300 PROCESS-UPDATE-FILE-EXIT.
040400     EXIT.
040500*
040600 PROCESS-UPDATE-RECORD.
040700*
040800     IF WSUR-KEY = LOW-VALUES
040900         MOVE UPDATE-KEY TO WSUR-KEY
041000         MOVE WSUR-ID TO WS-NOMINAL-ID
041100         PERFORM READ-ISAM-MASTER
041200            THRU READ-ISAM-MASTER-EXIT
041300     ELSE
041400         IF UPDATE-KEY NOT = WSUR-KEY
041500             PERFORM PROCESS-UPDATE-SET
041600                THRU PROCESS-UPDATE-SET-EXIT
041700             MOVE LOW-VALUES TO WS-UPDATE-RECORD
041800             MOVE UPDATE-KEY TO WSUR-KEY
041900             MOVE WSUR-ID TO WS-NOMINAL-ID
042000             PERFORM READ-ISAM-MASTER
042100                THRU READ-ISAM-MASTER-EXIT
042200     .
042300*
042400     MOVE 'Y' TO UPDATE-RECORD-VALID-SW.
042500*
042600     IF UPDATE-ID IS NOT NUMERIC
042700         SET EMX TO 1
042800         GENERATE VALIDATE-ERROR-DETAIL
042900         MOVE 'N' TO UPDATE-RECORD-VALID-SW
043000     .
043100*
043200     IF NOT ACTION-IS-VALID
043300         SET EMX TO 2
043400         GENERATE VALIDATE-ERROR-DETAIL
043500         MOVE 'N' TO UPDATE-RECORD-VALID-SW
043600     .
043700*
043800     IF ACTION-IS-CHANGE
043900     OR ACTION-IS-ADD
044000         IF NOT VALID-UPDATE-FIELD
044100             SET EMX TO 3
044200             GENERATE VALIDATE-ERROR-DETAIL
044300             MOVE 'N' TO UPDATE-RECORD-VALID-SW
044400     .
044500*
044600     IF UPDATE-RECD-VALID AND
044700       (ACTION-IS-CHANGE OR ACTION-IS-ADD)
044800            PERFORM VALIDATE-UPDATE-DATA
044900               THRU VALIDATE-UPDATE-DATA-EXIT
045000     .
045100     IF ACTION-IS-CHANGE
045200     OR ACTION-IS-DELETE
045300         IF READ-INVALID-KEY
045400             SET EMX TO 15
045500             GENERATE VALIDATE-ERROR-DETAIL
045600             ADD 1 TO UNMATCHED-CHANGE-COUNT
045700             MOVE 'N' TO UPDATE-RECORD-VALID-SW
045800         ELSE
045900             NEXT SENTENCE
046000     ELSE
046100         IF NOT READ-INVALID-KEY
046200             SET EMX TO 14
046300             GENERATE VALIDATE-ERROR-DETAIL
046400             ADD 1 TO DUPLICATE-ADD-COUNT
046500             MOVE 'N' TO UPDATE-RECORD-VALID-SW
046600         ELSE
046700             NEXT SENTENCE
046800     .
046900*
047000     IF NOT UPDATE-RECD-VALID
047100         ADD 1 TO ERRONEOUS-UPDATE-COUNT
047200     .
047300*
047400 PROCESS-UPDATE-RECORD-EXIT.
047500     EXIT.
047600*
047700 VALIDATE-UPDATE-DATA.
047800*
047900     IF UPDATE-FIELD-FIRST-NAME
048000         PERFORM VALIDATE-FIRST-NAME
048100            THRU VALIDATE-FIRST-NAME-EXIT
048200     .
048300     IF UPDATE-FIELD-INITIAL
048400         MOVE UPDATE-DATA-INITIAL TO WSUR-INITIAL
048500     .
048600     IF UPDATE-FIELD-LAST-NAME
048700         PERFORM VALIDATE-LAST-NAME
048800            THRU VALIDATE-LAST-NAME-EXIT
048900     .
049000     IF UPDATE-FIELD-STREET
049100         PERFORM VALIDATE-STREET
049200            THRU VALIDATE-STREET-EXIT
049300     .
049400     IF UPDATE-FIELD-CITY
049500         PERFORM VALIDATE-CITY
049600            THRU VALIDATE-CITY-EXIT
049700     .
049800     IF UPDATE-FIELD-GENDER
049900         PERFORM VALIDATE-GENDER
050000            THRU VALIDATE-GENDER-EXIT
050100     .
050200     IF UPDATE-FIELD-PHONE
050300         PERFORM VALIDATE-PHONE
050400            THRU VALIDATE-PHONE-EXIT
050500     .
050600     IF UPDATE-FIELD-DATE1
050700     OR UPDATE-FIELD-DATE2
050800     OR UPDATE-FIELD-DATE3
050900         PERFORM VALIDATE-DATE
051000            THRU VALIDATE-DATE-EXIT
051100     .
051200*
051300 VALIDATE-UPDATE-DATA-EXIT.
051400     EXIT.
051500*
051600 VALIDATE-FIRST-NAME.
051700*
051800     IF UPDATE-DATA-FIRST-NAME = SPACES
051900         SET EMX TO 4
052000         GENERATE VALIDATE-ERROR-DETAIL
052100         MOVE 'N' TO UPDATE-RECORD-VALID-SW
052200     ELSE
052300         MOVE UPDATE-DATA-FIRST-NAME TO WSUR-FIRST-NAME
052400     .
052500*
052600 VALIDATE-FIRST-NAME-EXIT.
052700     EXIT.
052800*
052900 VALIDATE-LAST-NAME.
053000*
053100     IF UPDATE-DATA-LAST-NAME = SPACES
053200         SET EMX TO 5
053300         GENERATE VALIDATE-ERROR-DETAIL
053400         MOVE 'N' TO UPDATE-RECORD-VALID-SW
053500     ELSE
053600         MOVE UPDATE-DATA-LAST-NAME TO WSUR-LAST-NAME
053700     .
053800*
053900 VALIDATE-LAST-NAME-EXIT.
054000     EXIT.
054100*
054200 VALIDATE-STREET.
054300*
054400     IF UPDATE-DATA-STREET = SPACES
054500         SET EMX TO 6
054600         GENERATE VALIDATE-ERROR-DETAIL
054700         MOVE 'N' TO UPDATE-RECORD-VALID-SW
054800     ELSE
054900         MOVE UPDATE-DATA-STREET TO WSUR-STREET
055000     .
055100*
055200 VALIDATE-STREET-EXIT.
055300     EXIT.
055400*
055500 VALIDATE-CITY.
055600*
055700     IF UPDATE-DATA-CITY = SPACES
055800         SET EMX TO 7
055900         GENERATE VALIDATE-ERROR-DETAIL
056000         MOVE 'N' TO UPDATE-RECORD-VALID-SW
056100     ELSE
056200         MOVE UPDATE-DATA-CITY TO WSUR-CITY
056300     .
056400*
056500 VALIDATE-CITY-EXIT.
056600     EXIT.
056700*
056800 VALIDATE-GENDER.
056900*
057000     IF UPDATE-DATA-GENDER = 'M'
057100     OR UPDATE-DATA-GENDER = 'F'
057200         MOVE UPDATE-DATA-GENDER TO WSUR-GENDER
057300     ELSE
057400         SET EMX TO 8
057500         GENERATE VALIDATE-ERROR-DETAIL
057600         MOVE 'N' TO UPDATE-RECORD-VALID-SW
057700     .
057800*
057900 VALIDATE-GENDER-EXIT.
058000     EXIT.
058100*
058200 VALIDATE-PHONE.
058300*
058400     IF UPDATE-DATA-PHONE IS NOT NUMERIC
058500         SET EMX TO 9
058600         GENERATE VALIDATE-ERROR-DETAIL
058700         MOVE 'N' TO UPDATE-RECORD-VALID-SW
058800     ELSE
058900         MOVE UPDATE-DATA-PHONE TO WSUR-PHONE
059000     .
059100*
059200 VALIDATE-PHONE-EXIT.
059300     EXIT.
059400*
059500 VALIDATE-DATE.
059600*
059700     MOVE UPDATE-DATA-DATE TO GTOAP-DATE-G.
059800     CALL 'Y2KGTOA' USING GTOA-PARAMETERS.
059900     IF GTOAP-RETURN-CODE = 2
060000         SET EMX TO 10
060100         GENERATE VALIDATE-ERROR-DETAIL
060200         MOVE 'N' TO UPDATE-RECORD-VALID-SW
060300     .
060400     IF GTOAP-RETURN-CODE = 4
060500         SET EMX TO 11
060600         GENERATE VALIDATE-ERROR-DETAIL
060700         MOVE 'N' TO UPDATE-RECORD-VALID-SW
060800     .
060900     IF GTOAP-RETURN-CODE = 6
061000         SET EMX TO 12
061100         GENERATE VALIDATE-ERROR-DETAIL
061200         MOVE 'N' TO UPDATE-RECORD-VALID-SW
061300     .
061400     IF GTOAP-RETURN-CODE = 8
061500         SET EMX TO 13
061600         GENERATE VALIDATE-ERROR-DETAIL
061700         MOVE 'N' TO UPDATE-RECORD-VALID-SW
061800     .
061900     IF GTOAP-RETURN-CODE = 0
062000     AND UPDATE-FIELD-DATE1
062100         MOVE UPDATE-DATA-DATE TO WSUR-DATE1.
062200     IF GTOAP-RETURN-CODE = 0
062300     AND UPDATE-FIELD-DATE2
062400         MOVE UPDATE-DATA-DATE TO WSUR-DATE2.
062500     IF GTOAP-RETURN-CODE = 0
062600     AND UPDATE-FIELD-DATE3
062700         MOVE UPDATE-DATA-DATE TO WSUR-DATE3.
062800*
062900 VALIDATE-DATE-EXIT.
063000     EXIT.
063100*
063200 PROCESS-UPDATE-SET.
063300*
063400     IF ACTION-IS-CHANGE
063500     OR ACTION-IS-DELETE
063600         IF NOT READ-INVALID-KEY
063700             PERFORM APPLY-UPDATES-TO-MASTER
063800                THRU APPLY-UPDATES-TO-MASTER-EXIT
063900         ELSE
064000             NEXT SENTENCE
064100*            NO ACTION, BECAUSE THIS IS AN ERROR WHICH HAS
064200*            ALREADY BEEN REPORTED
064300     ELSE
064400     IF ACTION-IS-ADD
064500         IF READ-INVALID-KEY
064600             PERFORM ADD-NEW-MASTER
064700                THRU ADD-NEW-MASTER-EXIT
064800         ELSE
064900             NEXT SENTENCE
065000*            NO ACTION, BECAUSE THIS IS AN ERROR WHICH HAS
065100*            ALREADY BEEN REPORTED
065200     .
065300*
065400 PROCESS-UPDATE-SET-EXIT.
065500     EXIT.
065600*
065700 APPLY-UPDATES-TO-MASTER.
065800*
065900     SET DTX TO 1.
066000     GENERATE RECORD-FIELDS-DETAIL.
066100
066200     IF ACTION-IS-DELETE
066300         MOVE DELETE-FLAG-BYTE TO MR-DELETE-CODE
066400     ELSE
066500         PERFORM UPDATE-ISAM-MASTER-FIELDS
066600            THRU UPDATE-ISAM-MASTER-FIELDS-EXIT
066700     .
066800     IF WS-ORIGINAL-DELETE-CODE NOT = MR-DELETE-CODE
066900         SET DTX TO 4
067000     ELSE
067100         SET DTX TO 2
067200     .
067300     GENERATE RECORD-FIELDS-DETAIL.
067400     PERFORM REWRITE-ISAM-MASTER
067500        THRU REWRITE-ISAM-MASTER-EXIT.
067600*
067700 APPLY-UPDATES-TO-MASTER-EXIT.
067800     EXIT.
067900*
068000 ADD-NEW-MASTER.
068100*
068200     MOVE SPACES TO MASTER-RECD.
068300     MOVE ZEROS TO MR-TELEPHONE, MR-DATE-1,
068400                   MR-DATE-2, MR-DATE-3
068500     MOVE WSUR-ID TO MR-ID
068600     PERFORM UPDATE-ISAM-MASTER-FIELDS
068700        THRU UPDATE-ISAM-MASTER-FIELDS-EXIT.
068800     SET DTX TO 3.
068900     GENERATE RECORD-FIELDS-DETAIL.
069000     PERFORM WRITE-ISAM-MASTER
069100        THRU WRITE-ISAM-MASTER-EXIT.
069200*
069300 ADD-NEW-MASTER-EXIT.
069400     EXIT.
069500*
069600 READ-ISAM-MASTER.
069700*
069800     MOVE SPACE TO WS-ORIGINAL-DELETE-CODE.
069900     MOVE 'N' TO READ-INVALID-KEY-SW.
070000     READ ISAM-MASTER
070100         INVALID KEY
070200             MOVE 'Y' TO READ-INVALID-KEY-SW
070300             MOVE LOW-VALUES TO MASTER-RECD
070400     .
070500     IF NOT READ-INVALID-KEY
070600         MOVE MR-DELETE-CODE TO WS-ORIGINAL-DELETE-CODE.
070700*
070800 READ-ISAM-MASTER-EXIT.
070900     EXIT.
071000*
071100 REWRITE-ISAM-MASTER.
071200*
071300     MOVE 'N' TO REWRITE-INVALID-KEY-SW.
071400     REWRITE MASTER-RECD
071500         INVALID KEY
071600             MOVE 'Y' TO REWRITE-INVALID-KEY-SW
071700             SET EMX TO 16
071800             GENERATE WRITE-ERROR-DETAIL
071900     .
072000     IF NOT REWRITE-INVALID-KEY
072100         IF WS-ORIGINAL-DELETE-CODE NOT = MR-DELETE-CODE
072200             ADD 1 TO DELETED-RECORD-COUNT
072300         ELSE
072400             ADD 1 TO CHANGED-RECORD-COUNT
072500     .
072600*
072700 REWRITE-ISAM-MASTER-EXIT.
072800     EXIT.
072900*
073000 WRITE-ISAM-MASTER.
073100*
073200     MOVE 'N' TO WRITE-INVALID-KEY-SW.
073300     WRITE MASTER-RECD
073400         INVALID KEY
073500             MOVE 'Y' TO WRITE-INVALID-KEY-SW
073600             SET EMX TO 17
073700             GENERATE WRITE-ERROR-DETAIL
073800     .
073900     IF NOT WRITE-INVALID-KEY
074000         ADD 1 TO ADDED-RECORD-COUNT
074100     .
074200*
074300 WRITE-ISAM-MASTER-EXIT.
074400     EXIT.
074500*
074600 UPDATE-ISAM-MASTER-FIELDS.
074700*
074800     IF WSUR-FIRST-NAME NOT = LOW-VALUES
074900         MOVE WSUR-FIRST-NAME TO MR-FIRST-NAME.
075000     IF WSUR-INITIAL NOT = LOW-VALUES
075100         MOVE WSUR-INITIAL TO MR-INITIAL.
075200     IF WSUR-LAST-NAME NOT = LOW-VALUES
075300         MOVE WSUR-LAST-NAME TO MR-LAST-NAME.
075400     CALL 'SORTNAME' USING MR-FIRST-NAME, MR-LAST-NAME,
075500                           MR-INITIAL, MR-SORT-NAME.
075600     IF WSUR-STREET NOT = LOW-VALUES
075700         MOVE WSUR-STREET TO MR-STREET.
075800     IF WSUR-CITY NOT = LOW-VALUES
075900         MOVE WSUR-CITY TO MR-CITY-STATE-ZIP.
076000     IF WSUR-GENDER NOT = LOW-VALUES
076100         MOVE WSUR-GENDER TO MR-GENDER-CODE.
076200     IF WSUR-PHONE NOT = LOW-VALUES
076300         MOVE WSUR-PHONE TO MR-TELEPHONE.
076400     IF WSUR-DATE1 NOT = LOW-VALUES
076500         MOVE WSUR-DATE1 TO MR-DATE-1.
076600     IF WSUR-DATE2 NOT = LOW-VALUES
076700         MOVE WSUR-DATE2 TO MR-DATE-2.
076800     IF WSUR-DATE3 NOT = LOW-VALUES
076900         MOVE WSUR-DATE3 TO MR-DATE-3.
077000*
077100 UPDATE-ISAM-MASTER-FIELDS-EXIT.
077200     EXIT.
077300*
077400* END OF PROGRAM ISUPDT.
./ ADD NAME=JCOBUCL1 0103-21348-21350-0751-00021-00016-00008-JAY01   48
//COBUCL1  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000100
//*                                                                     00000203
//* ***************************************************************** * 00000303
//* * COMPILE MAIN PROGRAM -ISLOAD- AND SUBPROGRAM -SORTNAME- AND   * * 00000403
//* * LINK INTO LOAD MODULE -ISLOAD-                                * * 00000503
//* ***************************************************************** * 00000603
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                  00000700
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(ISLOAD)                    00000800
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS),UNIT=SYSDA,                00000900
//             SPACE=(80,(500,100))                                     00001000
//COBUCL   EXEC COBUCL,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                 00001100
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(SORTNAME)                  00001200
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00001302
//LKED.SYSLIB DD                                                        00001400
//   DD DISP=SHR,DSN=SYSC.COBLIB                                        00001500
//LKED.SYSIN DD *                                                       00001600
  NAME ISLOAD(R)                                                        00001701
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00001800
//         PARM='USER=(JAY01)'                                          00001900
//SYSPRINT DD   SYSOUT=*                                                00002000
//                                                                      00002103
./ ADD NAME=JCOBUCL2 0102-21348-21350-0753-00017-00012-00006-JAY01   28
//COBUCL2  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000100
//*                                                                     00000202
//* ***************************************************************** * 00000302
//* * COMPILE MAIN PROGRAM -ISREPT1 - AND  LINK INTO LOAD MODULE    * * 00000402
//* * -ISREPT1-                                                     * * 00000502
//* ***************************************************************** * 00000602
//COBUCL   EXEC COBUCL,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                 00000700
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(ISREPT1)                   00000800
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00000901
//LKED.SYSLIB DD                                                        00001000
//   DD DISP=SHR,DSN=SYSC.COBLIB                                        00001100
//LKED.SYSIN DD *                                                       00001200
  NAME ISREPT1(R)                                                       00001300
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00001400
//         PARM='USER=(JAY01)'                                          00001500
//SYSPRINT DD   SYSOUT=*                                                00001600
//                                                                      00001700
./ ADD NAME=JCOBUCL3 0103-21348-21350-0753-00017-00012-00008-JAY01   43
//COBUCL3  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000102
//*                                                                     00000203
//* ***************************************************************** * 00000303
//* * COMPILE MAIN PROGRAM -ISREPT2 - AND  LINK INTO LOAD MODULE    * * 00000403
//* * -ISREPT2-                                                     * * 00000503
//* ***************************************************************** * 00000603
//COBUCL   EXEC COBUCL,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                 00000700
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(ISREPT2)                   00000802
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00000900
//LKED.SYSLIB DD                                                        00001000
//   DD DISP=SHR,DSN=SYSC.COBLIB                                        00001100
//LKED.SYSIN DD *                                                       00001200
  NAME ISREPT2(R)                                                       00001302
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00001400
//         PARM='USER=(JAY01)'                                          00001500
//SYSPRINT DD   SYSOUT=*                                                00001600
//                                                                      00001700
./ ADD NAME=JCOBUCL4 0101-21348-21350-0825-00028-00012-00027-JAY01   31
//COBUCL4  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000101
//*                                                                     00000201
//* ***************************************************************** * 00000301
//* * COMPILE MAIN PROGRAM -ISUPDT- SUBPROGRAM -SORTNAME- AND       * * 00000401
//* * SUBPROGRAM -Y2KGTOA- AND LINK INTO LOAD MODULE -ISUPDT-       * * 00000501
//* ***************************************************************** * 00000601
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                  00000701
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(ISUPDT)                    00000801
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS),UNIT=SYSDA,                00000901
//             SPACE=(80,(1000,500))                                    00001001
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                  00001101
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(SORTNAME)                  00001201
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS)                            00001301
//ASMXCL   EXEC ASMXCL,PARM.LKED=(XREF,LET,LIST),                       00001401
//             MAC1='SYSC.Y2K.SOURCE'                                   00001501
//ASM.SYSPRINT DD SYSOUT=*                                              00001601
//ASM.SYSGO DD DSN=&LOADSET,DISP=(MOD,PASS)                             00001701
//ASM.SYSIN DD DISP=SHR,DSN=SYSC.Y2K.SOURCE(Y2KGTOA)                    00001801
//LKED.SYSLIN DD DSN=&LOADSET                                           00001901
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00002000
//LKED.SYSPRINT DD SYSOUT=*                                             00002101
//LKED.SYSLIB DD DISP=SHR,DSN=SYSC.COBLIB                               00002201
//LKED.SYSIN DD *                                                       00002301
  NAME ISUPDT(R)                                                        00002401
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00002501
//         PARM='USER=(JAY01)'                                          00002601
//SYSPRINT DD   SYSOUT=*                                                00002701
//                                                                      00002801
./ ADD NAME=JCOBUCL5 0100-21356-21356-1044-00023-00023-00000-JAY01   16
//COBUCL5  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000100
//*                                                                     00000203
//* ***************************************************************** * 00000303
//* * COMPILE MAIN PROGRAM -VSLOAD- AND SUBPROGRAM -SORTNAME- AND   * * 00000403
//* * LINK INTO LOAD MODULE -VSLOAD-                                * * 00000503
//* ***************************************************************** * 00000603
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP,LIB'              00000700
//COB.SYSLIB DD DISP=SHR,DSN=SYSC.VSAMIO.SOURCE
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(VSLOAD)                    00000800
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS),UNIT=SYSDA,                00000900
//             SPACE=(80,(500,100))                                     00001000
//COBUCL   EXEC COBUCL,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                 00001100
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(SORTNAME)                  00001200
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00001302
//LKED.SYSLIB DD                                                        00001400
//   DD DISP=SHR,DSN=SYSC.COBLIB                                        00001500
//   DD DISP=SHR,DSN=SYSC.LINKLIB
//LKED.SYSIN DD *                                                       00001600
  NAME VSLOAD(R)                                                        00001701
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00001800
//         PARM='USER=(JAY01)'                                          00001900
//SYSPRINT DD   SYSOUT=*                                                00002000
//                                                                      00002103
./ ADD NAME=JCOBUCL6 0102-21356-21356-1223-00023-00023-00004-JAY01   09
//COBUCL6  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000100
//*                                                                     00000200
//* ***************************************************************** * 00000300
//* * COMPILE MAIN PROGRAM -VSREPT- AND LINK INTO LOAD MODULE       * * 00000402
//* * -VSREPT-                                                      * * 00000502
//* ***************************************************************** * 00000600
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP,LIB'              00000700
//COB.SYSLIB DD DISP=SHR,DSN=SYSC.VSAMIO.SOURCE                         00000800
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(VSREPT)                    00000902
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS),UNIT=SYSDA,                00001000
//             SPACE=(80,(500,100))                                     00001100
//COBUCL   EXEC COBUCL,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                 00001200
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(SORTNAME)                  00001300
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00001400
//LKED.SYSLIB DD                                                        00001500
//   DD DISP=SHR,DSN=SYSC.COBLIB                                        00001600
//   DD DISP=SHR,DSN=SYSC.LINKLIB                                       00001700
//LKED.SYSIN DD *                                                       00001800
  NAME VSREPT(R)                                                        00001902
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00002000
//         PARM='USER=(JAY01)'                                          00002100
//SYSPRINT DD   SYSOUT=*                                                00002200
//                                                                      00002300
./ ADD NAME=JCOBUCL7 0100-21356-21356-1611-00030-00030-00000-JAY01   06
//COBUCL7  JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00000100
//*                                                                     00000200
//* ***************************************************************** * 00000300
//* * COMPILE MAIN PROGRAM -VSUPDT- AND SUBPROGRAMS -SORTNAME- AND  * * 00000400
//* * -Y2KGTOA- AND LINK INTO LOAD MODULE -VSUPDT-                  * * 00000500
//* ***************************************************************** * 00000600
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP,LIB'              00000700
//COB.SYSLIB DD DISP=SHR,DSN=SYSC.VSAMIO.SOURCE                         00000800
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(VSUPDT)                    00000900
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS),UNIT=SYSDA,                00001000
//             SPACE=(80,(1000,500))                                    00001100
//COBUC    EXEC COBUC,CPARM1='NODECK,LOAD,DMAP,SUPMAP'                  00001200
//COB.SYSIN DD DISP=SHR,DSN=JAY01.ISAM.COBOL(SORTNAME)                  00001300
//COB.SYSLIN DD DSN=&LOADSET,DISP=(MOD,PASS)                            00001400
//ASMXCL   EXEC ASMXCL,PARM.LKED=(XREF,LET,LIST),                       00001500
//             MAC1='SYSC.Y2K.SOURCE'                                   00001600
//ASM.SYSPRINT DD SYSOUT=*                                              00001700
//ASM.SYSGO DD DSN=&LOADSET,DISP=(MOD,PASS)                             00001800
//ASM.SYSIN DD DISP=SHR,DSN=SYSC.Y2K.SOURCE(Y2KGTOA)                    00001900
//LKED.SYSLIN DD DSN=&LOADSET                                           00002000
//LKED.SYSLMOD DD DISP=MOD,DSN=JAY01.LOAD              <<-TARGET        00002100
//LKED.SYSPRINT DD SYSOUT=*                                             00002200
//LKED.SYSLIB DD DISP=SHR,DSN=SYSC.COBLIB                               00002300
//            DD DISP=SHR,DSN=SYSC.LINKLIB    (FOR VSAMIO)              00002400
//LKED.SYSIN DD *                                                       00002500
  NAME VSUPDT(R)                                                        00002600
//COMPCODE EXEC PGM=COMPCODE,COND=EVEN,                                 00002700
//         PARM='USER=(JAY01)'                                          00002800
//SYSPRINT DD   SYSOUT=*                                                00002900
//                                                                      00003000
./ ADD NAME=JIEBISL  0103-21349-21355-1723-00022-00017-00005-JAY02   00
//IEBISAML JOB (1),'IEBISAM-RELOAD',                                    00010000
//             CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID              00020000
//*                                                                     00030002
//* ***************************************************************** * 00040002
//* * DELETE EXISTING ISAM DATASET AND EXECUTE IEBISAM UTILITY TO   * * 00050002
//* * RELOAD FROM BACKUP (RECORDS FLAGGED FOR DELETION OMITTED)     * * 00060002
//* ***************************************************************** * 00070002
//CLEANUP  EXEC PGM=IEHPROGM                                            00080000
//SYSPRINT DD SYSOUT=*                                                  00090000
//PUB000   DD UNIT=SYSDA,VOL=SER=PUB000,DISP=OLD                        00100000
//SYSIN    DD *                                                         00110000
  SCRATCH DSNAME=JAY01.ISAM.MASTER,VOL=SYSDA=PUB000                     00120000
  UNCATLG DSNAME=JAY01.ISAM.MASTER                                      00130000
/*                                                                      00140000
//IEBISAM EXEC PGM=IEBISAM,PARM='LOAD'                                  00150000
//SYSPRINT DD SYSOUT=*                                                  00160000
//SYSUT1   DD DISP=OLD,DSN=JAY01.ISAM.MASTER.BACKUP                     00170000
//SYSUT2   DD DISP=(NEW,CATLG,DELETE),DSN=JAY01.ISAM.MASTER,            00180000
//            UNIT=SYSDA,VOL=SER=PUB000,SPACE=(CYL,(5,1)),              00190000
//            DCB=(DSORG=IS,RECFM=FB,LRECL=200,BLKSIZE=23400,           00200000
//            KEYLEN=7,RKP=1,CYLOFL=2,NTM=4,OPTCD=LMY)                  00210000
//                                                                      00220000
./ ADD NAME=JIEBISL2 0102-21356-21356-0642-00032-00035-00001-JAY01   10
//IEBISML2 JOB (1),'IEBISAM-RELOAD IVI',                                00000100
//             CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID              00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * ==================== ISAM/VSAM INTERFACE ==================== * * 00000500
//* * DELETE EXISTING ISAM DATASET AND EXECUTE IEBISAM UTILITY TO   * * 00000600
//* * RELOAD FROM BACKUP (RECORDS FLAGGED FOR DELETION OMITTED)     * * 00000700
//* ***************************************************************** * 00000800
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M                                     00000900
//SYSPRINT DD SYSOUT=*                                                  00001000
//SYSIN    DD *                                                         00001100
   /* DELETE KSDS CLUSTER, IF IT EXISTS                      */         00001200
   DELETE JAY01.ISAMIVI.MASTER CLUSTER PURGE                            00001300
   /* DEFINE KSDS CLUSTER                                    */         00001400
   DEFINE CLUSTER (                                          -          00001500
                NAME(JAY01.ISAMIVI.MASTER)                   -          00001600
                VOLUMES(PUB000)                              -          00001700
                RECORDSIZE(200 200)                          -          00001800
                RECORDS(2600 0)                              -          00001900
                KEYS(07 1)                                   -          00002000
                INDEXED                                      -          00002100
                UNIQUE  )                                    -          00002200
          DATA (                                             -          00002300
                NAME(JAY01.ISAMIVI.MASTER.DATA) )            -          00002400
          INDEX (                                            -          00002500
                NAME(JAY01.ISAMIVI.MASTER.INDEX) )                      00002600
/*                                                                      00002700
//IEBISAM EXEC PGM=IEBISAM,PARM='LOAD'                                  00002800
//SYSPRINT DD SYSOUT=*                                                  00002900
//SYSUT1   DD DISP=OLD,DSN=JAY01.ISAM.MASTER.BACKUP                     00003000
//SYSUT2   DD DISP=SHR,DSN=JAY01.ISAMIVI.MASTER,AMP='AMORG'             00003102
//                                                                      00003200
./ ADD NAME=JIEBISU  0105-21349-21355-1723-00013-00009-00013-JAY02   00
//IEBISAMU JOB (1),'IEBISAM-UNLOAD',                                    00010002
//             CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID              00020001
//*                                                                     00030003
//* ***************************************************************** * 00040003
//* * EXECUTE IEBISAM TO COPY ISAM DATASET TO BACKUP                * * 00050003
//* ***************************************************************** * 00060003
//IEBISAM EXEC PGM=IEBISAM,PARM='UNLOAD'                                00070005
//SYSPRINT DD SYSOUT=*                                                  00080002
//SYSUT1   DD DISP=SHR,DSN=JAY01.ISAM.MASTER,DCB=DSORG=IS               00090004
//SYSUT2   DD DISP=(NEW,CATLG,DELETE),UNIT=SYSDA,VOL=SER=PUB000,        00100001
//            DSN=JAY01.ISAM.MASTER.BACKUP,SPACE=(CYL,(5,5),RLSE),      00110001
//            DCB=(RECFM=FB,LRECL=80,BLKSIZE=23440)                     00120004
//                                                                      00130001
./ ADD NAME=JIEBISU2 0100-21356-21356-0635-00013-00013-00000-JAY01   38
//IEBISMU2 JOB (1),'IEBISAM-UNLOAD IVI',                                00000100
//             CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID              00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * EXECUTE IEBISAM TO COPY ISAM DATASET TO BACKUP                * * 00000500
//* ***************************************************************** * 00000600
//IEBISAM EXEC PGM=IEBISAM,PARM='UNLOAD'                                00000700
//SYSPRINT DD SYSOUT=*                                                  00000800
//SYSUT1   DD DISP=SHR,DSN=JAY01.ISAMIVI.MASTER,DCB=DSORG=IS            00000900
//SYSUT2   DD DISP=(NEW,CATLG,DELETE),UNIT=SYSDA,VOL=SER=PUB000,        00001000
//            DSN=JAY01.ISAM.MASTER.BACKUP,SPACE=(CYL,(5,5),RLSE),      00001100
//            DCB=(RECFM=FB,LRECL=80,BLKSIZE=23440)                     00001200
//                                                                      00001300
./ ADD NAME=JISLOAD1 0105-21348-21351-1156-00026-00013-00019-JAY01   43
//JLOADIS1 JOB (1),'LOAD NATIVE ISAM',                                  00000102
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000303
//* ***************************************************************** * 00000403
//* * ====================== NATIVE ISAM ========================== * * 00000503
//* * DELETE EXISTING ISAM DATASET, THEN CREATE NEW ISAM DATASET    * * 00000603
//* * LOADING RECORDS FROM SEQUENTIAL DATASET ON TAPE               * * 00000703
//* ***************************************************************** * 00000803
//CLEANUP  EXEC PGM=IEHPROGM                                            00000902
//SYSPRINT DD SYSOUT=*                                                  00001002
//PUB000   DD UNIT=SYSDA,VOL=SER=PUB000,DISP=OLD                        00001102
//SYSIN    DD *                                                         00001202
  SCRATCH DSNAME=JAY01.ISAM.MASTER,VOL=SYSDA=PUB000                     00001302
  UNCATLG DSNAME=JAY01.ISAM.MASTER                                      00001402
/*                                                                      00001502
//LOADISAM EXEC PGM=ISLOAD                                              00001602
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001700
//SYSUT1   DD DISP=OLD,UNIT=TAPE,VOL=SER=210347,DSN=NEW.MASTER.DATA,    00001800
//            LABEL=(1,SL)                                              00001900
//SYSUDUMP DD SYSOUT=*                                                  00002000
//MASTER   DD DISP=(NEW,CATLG,DELETE),DSN=JAY01.ISAM.MASTER,            00002102
//            UNIT=SYSDA,VOL=SER=PUB000,SPACE=(CYL,(10,1)),             00002205
//            DCB=(DSORG=IS,RECFM=FB,LRECL=200,BLKSIZE=200,             00002305
//            KEYLEN=7,RKP=1,CYLOFL=2,NTM=4,OPTCD=LMY)                  00002401
//SYSOUT   DD SYSOUT=*                                                  00002500
//                                                                      00002600
./ ADD NAME=JISLOAD2 0101-21349-21350-0924-00038-00031-00007-JAY01   32
//JLOADIS2 JOB (1),'LOAD IS/VS CLUST',CLASS=A,MSGCLASS=X,NOTIFY=&SYSUID 00000100
//*                                                                     00000201
//* ***************************************************************** * 00000301
//* * ==================== ISAM/VSAM INTERFACE ==================== * * 00000401
//* * DELETE EXISTING VSAM DATASET, THEN DEFINE NEW VSAM DATASET,   * * 00000501
//* * PRIME NEW DATASET TO RECEIVE RECORDS, THEN LOAD RECORDS FROM  * * 00000601
//* * SEQUENTIAL DATASET ON TAPE                                    * * 00000701
//* ***************************************************************** * 00000801
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M                                     00000900
//SYSPRINT DD SYSOUT=*                                                  00001000
//SYSIN    DD *                                                         00001100
   /* DELETE KSDS CLUSTER, IF IT EXISTS                      */         00001200
   DELETE JAY01.ISAMIVI.MASTER CLUSTER PURGE                            00001300
   /* DEFINE KSDS CLUSTER                                    */         00001400
   DEFINE CLUSTER (                                          -          00001500
                NAME(JAY01.ISAMIVI.MASTER)                   -          00001600
                VOLUMES(PUB000)                              -          00001700
                RECORDSIZE(200 200)                          -          00001800
                RECORDS(2600 0)                              -          00001900
                KEYS(07 1)                                   -          00002000
                INDEXED                                      -          00002100
                UNIQUE  )                                    -          00002200
          DATA (                                             -          00002300
                NAME(JAY01.ISAMIVI.MASTER.DATA) )            -          00002400
          INDEX (                                            -          00002500
                NAME(JAY01.ISAMIVI.MASTER.INDEX) )                      00002600
/*                                                                      00002700
//PRIMEVS EXEC PGM=PRIMEVS,REGION=1M                                    00002800
//DS       DD DSN=JAY01.ISAMIVI.MASTER,DISP=SHR                         00002900
//LOADISAM EXEC PGM=ISLOAD                                              00003000
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00003100
//SYSUT1   DD DISP=OLD,UNIT=TAPE,VOL=SER=210347,DSN=NEW.MASTER.DATA,    00003200
//            LABEL=(1,SL)                                              00003300
//SYSUDUMP DD SYSOUT=*                                                  00003400
//MASTER   DD DISP=MOD,DSN=JAY01.ISAMIVI.MASTER,                        00003500
//            AMP='AMORG,RECFM=F'                                       00003600
//SYSOUT   DD SYSOUT=*                                                  00003700
//                                                                      00003800
./ ADD NAME=JISREPT1 0102-21348-21350-0928-00014-00008-00006-JAY01   12
//JREPIS1 JOB (1),'ISAM PRI KEY REPORT',                                00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000301
//* ***************************************************************** * 00000401
//* * ====================== NATIVE ISAM ========================== * * 00000501
//* * READ RECORDS SEQUENTIALLY FROM ISAM DATASET IN PRIMARY KEY    * * 00000601
//* * SEQUENCE AND PRODUCE REPORT                                   * * 00000702
//* ***************************************************************** * 00000801
//ISREPT1  EXEC PGM=ISREPT1                                             00000900
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001000
//SYSUDUMP DD SYSOUT=*                                                  00001100
//MASTER   DD DISP=SHR,DSN=JAY01.ISAM.MASTER,DCB=DSORG=IS               00001200
//REPORT   DD SYSOUT=*                                                  00001300
//                                                                      00001400
./ ADD NAME=JISREPT2 0103-21348-21350-0926-00027-00021-00019-JAY01   24
//JREPIS2 JOB (1),'ISAM ALT KEY REPORT',                                00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000303
//* ***************************************************************** * 00000403
//* * ====================== NATIVE ISAM ========================== * * 00000503
//* * READ RECORDS SEQUENTIALLY FROM ISAM DATASET IN PRIMARY KEY    * * 00000603
//* * SEQUENCE, THEN SORT THEM AND PRODUCE REPORT                   * * 00000703
//* ***************************************************************** * 00000803
//ISREPT2  EXEC PGM=ISREPT2                                             00000900
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001000
//SYSUDUMP DD SYSOUT=*                                                  00001100
//MASTER   DD DISP=SHR,DSN=JAY01.ISAM.MASTER,DCB=DSORG=IS               00001200
//SORTLIB  DD DISP=SHR,DSN=SYSC.SORTLIB                                 00001301
//SORTWK01 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001401
//            SEP=(SORTWK02,SORTWK03,SORTWK04,SORTWK05,SORTWK06)        00001501
//SORTWK02 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001601
//            SEP=(SORTWK01,SORTWK03,SORTWK04,SORTWK05,SORTWK06)        00001701
//SORTWK03 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001801
//            SEP=(SORTWK01,SORTWK02,SORTWK04,SORTWK05,SORTWK06)        00001901
//SORTWK04 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002001
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK05,SORTWK06)        00002101
//SORTWK05 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002201
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK04,SORTWK06)        00002301
//SORTWK06 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002401
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK04,SORTWK05)        00002501
//REPORT   DD SYSOUT=*                                                  00002600
//                                                                      00002700
./ ADD NAME=JISREPT3 0103-21349-21350-0927-00014-00008-00008-JAY01   55
//JREPIS3 JOB (1),'IVI PRI KEY REPORT',                                 00000102
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000303
//* ***************************************************************** * 00000403
//* * ==================== ISAM/VSAM INTERFACE ==================== * * 00000503
//* * READ RECORDS SEQUENTIALLY FROM VSAM DATASET IN PRIMARY KEY    * * 00000603
//* * SEQUENCE USING ISAM/VSAM INTERFACE AND PRODUCE REPORT         * * 00000703
//* ***************************************************************** * 00000803
//ISREPT1  EXEC PGM=ISREPT1                                             00000900
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001000
//SYSUDUMP DD SYSOUT=*                                                  00001100
//MASTER   DD DISP=SHR,DSN=JAY01.ISAMIVI.MASTER,AMP='AMORG,RECFM=F'     00001201
//REPORT   DD SYSOUT=*                                                  00001300
//                                                                      00001400
./ ADD NAME=JISREPT4 0102-21349-21350-0929-00028-00021-00008-JAY01   28
//JREPIS4 JOB (1),'IVI ALT KEY REPORT',                                 00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000302
//* ***************************************************************** * 00000402
//* * ==================== ISAM/VSAM INTERFACE ==================== * * 00000502
//* * READ RECORDS SEQUENTIALLY FROM VSAM DATASET IN PRIMARY KEY    * * 00000602
//* * SEQUENCE USING ISAM/VSAM INTERFACE, THEN SORT THEM AND        * * 00000702
//* * PRODUCE REPORT                                                * * 00000802
//* ***************************************************************** * 00000902
//ISREPT2  EXEC PGM=ISREPT2                                             00001000
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001100
//SYSUDUMP DD SYSOUT=*                                                  00001200
//MASTER   DD DISP=SHR,DSN=JAY01.ISAMIVI.MASTER,AMP='AMORG,RECFM=F'     00001301
//SORTLIB  DD DISP=SHR,DSN=SYSC.SORTLIB                                 00001400
//SORTWK01 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001500
//            SEP=(SORTWK02,SORTWK03,SORTWK04,SORTWK05,SORTWK06)        00001600
//SORTWK02 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001700
//            SEP=(SORTWK01,SORTWK03,SORTWK04,SORTWK05,SORTWK06)        00001800
//SORTWK03 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00001900
//            SEP=(SORTWK01,SORTWK02,SORTWK04,SORTWK05,SORTWK06)        00002000
//SORTWK04 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002100
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK05,SORTWK06)        00002200
//SORTWK05 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002300
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK04,SORTWK06)        00002400
//SORTWK06 DD UNIT=SORTDA,SPACE=(CYL,(50,50)),                          00002500
//            SEP=(SORTWK01,SORTWK02,SORTWK03,SORTWK04,SORTWK05)        00002600
//REPORT   DD SYSOUT=*                                                  00002700
//                                                                      00002800
./ ADD NAME=JISUPDT1 0111-21348-21355-1750-00038-00024-00032-JAY02   00
//JUPDTIS1 JOB (1),'ISAM UPDATE',                                       00000110
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000301
//* ***************************************************************** * 00000401
//* * ====================== NATIVE ISAM ========================== * * 00000501
//* * READ UPDATE RECORDS FROM SEQUENTIAL DATASET (INSTREAM CARDS), * * 00000601
//* * VALIDATE FIELDS, THEN RETRIEVE ISAM RECORDS RANDOMLY AND      * * 00000701
//* * APPLY UPDATES (INCLUDING ADDITION OF RECORDS, CHANGING EXIST- * * 00000801
//* * ING RECORDS, AND FLAGGING RECORDS FOR DELETION)               * * 00000901
//* ***************************************************************** * 00001001
//ISUPDT   EXEC PGM=ISUPDT                                              00001111
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001200
//SYSUDUMP DD SYSOUT=*                                                  00001300
//SYSUT1   DD *                                                         00001400
0007505D                                         :OK                    00001505
0002126U03Stewardson                             :OK                    00001605
0006800A01Bryce                                  :OK                    00001705
0006800A02L                                      :OK                    00001807
0006800A03Williamson                             :OK                    00001907
0006800A044711 ES 18th Street                    :OK                    00002007
0006800A05Marietta, GA 30006                     :OK                    00002107
0006800A06F                                      :OK                    00002207
0006800A077708279615                             :OK                    00002307
0006800A0812132021                               :OK                    00002407
0006800A0910231993                               :OK                    00002507
0006800A1007212003                               :OK                    00002607
0164187U06F                                      :ERR                   00002705
0167576A01Thomas                                 :ERR                   00002808
0159125U074177364870                             :OK                    00002909
0989904D                                         :ERR                   00003005
0851361A01Toni                                   :ERR                   00003105
0851361A03Frain                                  :ERR                   00003205
0990500A01Mark                                   :OK                    00003308
0990500A03Thomas, Jr.                            :OK                    00003408
//MASTER   DD DISP=SHR,DSN=JAY01.ISAM.MASTER,                           00003503
//            DCB=(DSORG=IS,RECFM=FB,LRECL=200,BLKSIZE=23400)           00003603
//REPORT   DD SYSOUT=*                                                  00003700
//                                                                      00003900
./ ADD NAME=JISUPDT2 0100-21355-21355-1749-00037-00037-00000-JAY02   00
//JUPDTIS2 JOB (1),'IVI UPDATE',                                        00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * ==================== ISAM/VSAM INTERFACE ==================== * * 00000500
//* * READ UPDATE RECORDS FROM SEQUENTIAL DATASET (INSTREAM CARDS), * * 00000600
//* * VALIDATE FIELDS, THEN RETRIEVE ISAM RECORDS RANDOMLY AND      * * 00000700
//* * APPLY UPDATES (INCLUDING ADDITION OF RECORDS, CHANGING EXIST- * * 00000800
//* * ING RECORDS, AND FLAGGING RECORDS FOR DELETION)               * * 00000900
//* ***************************************************************** * 00001000
//ISUPDT   EXEC PGM=ISUPDT                                              00001100
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001200
//SYSUDUMP DD SYSOUT=*                                                  00001300
//SYSUT1   DD *                                                         00001400
0007505D                                         :OK                    00001500
0002126U03Stewardson                             :OK                    00001600
0006800A01Bryce                                  :OK                    00001700
0006800A02L                                      :OK                    00001800
0006800A03Williamson                             :OK                    00001900
0006800A044711 ES 18th Street                    :OK                    00002000
0006800A05Marietta, GA 30006                     :OK                    00002100
0006800A06F                                      :OK                    00002200
0006800A077708279615                             :OK                    00002300
0006800A0812132021                               :OK                    00002400
0006800A0910231993                               :OK                    00002500
0006800A1007212003                               :OK                    00002600
0164187U06F                                      :ERR                   00002700
0167576A01Thomas                                 :ERR                   00002800
0159125U074177364870                             :OK                    00002900
0989904D                                         :ERR                   00003000
0851361A01Toni                                   :ERR                   00003100
0851361A03Frain                                  :ERR                   00003200
0990500A01Mark                                   :OK                    00003300
0990500A03Thomas, Jr.                            :OK                    00003400
//MASTER   DD DISP=SHR,DSN=JAY01.ISAMIVI.MASTER,DCB=DSORG=IS            00003500
//REPORT   DD SYSOUT=*                                                  00003700
//                                                                      00003900
./ ADD NAME=JVSLOAD  0103-21356-21356-2309-00086-00056-00011-JAY01   03
//JLOADVS  JOB (1),'LOAD VSAM',                                         00000102
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000301
//* ***************************************************************** * 00000401
//* * DELETE EXISTING VSAM CLUSTER, DEFINE NEW VSAM CLUSTER, THEN   * * 00000500
//* * LOAD RECORDS FROM SEQUENTIAL DATASET ON TAPE                  * * 00000600
//* ***************************************************************** * 00000700
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M                                     00000800
//SYSPRINT DD SYSOUT=*                                                  00000900
//SYSIN    DD *                                                         00001000
                                                                        00001100
   /* DELETE KSDS CLUSTER AND ASSOCIATED OBJECTS, IF EXISTS  */         00001200
   DELETE JAY01.VSAM.MASTER CLUSTER PURGE                               00001300
                                                                        00001400
   /* DEFINE KSDS CLUSTER                                    */         00001500
   DEFINE CLUSTER (                                          -          00001600
                NAME(JAY01.VSAM.MASTER)                      -          00001700
                VOLUMES(PUB000)                              -          00001800
                RECORDSIZE(200 200)                          -          00001900
                RECORDS(2600 0)                              -          00002000
                KEYS(07 1)                                   -          00002100
                INDEXED                                      -          00002200
                UNIQUE  )                                    -          00002300
          DATA (                                             -          00002400
                NAME(JAY01.VSAM.MASTER.DATA) )               -          00002500
          INDEX (                                            -          00002600
                NAME(JAY01.VSAM.MASTER.INDEX) )                         00002700
                                                                        00002800
   SET LASTCC = 0                                                       00002900
   SET MAXCC = 0                                                        00003000
                                                                        00003100
/*                                                                      00003200
//LOADISAM EXEC PGM=VSLOAD,REGION=4M                                    00003300
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00003400
//SYSUT1   DD DISP=OLD,UNIT=TAPE,VOL=SER=210347,DSN=NEW.MASTER.DATA,    00003500
//            LABEL=(1,SL)                                              00003600
//SYSUDUMP DD SYSOUT=*                                                  00003700
//MASTER   DD DISP=MOD,DSN=JAY01.VSAM.MASTER                            00003800
//SYSOUT   DD SYSOUT=*                                                  00003900
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M,COND=(0,NE)                         00004000
//SYSPRINT DD SYSOUT=*                                                  00004100
//SYSIN    DD *                                                         00004200
                                                                        00004300
   /* DELETE ALTERNATE INDEX, IF IT EXISTS                   */         00004400
                                                                        00004500
    DELETE JAY01.VSAM.MASTER.AIX ALTERNATEINDEX PURGE                   00004603
                                                                        00004703
    SET LASTCC = 0                                                      00004803
                                                                        00004900
   /* DEFINE ALTERNATE INDEX WITH UNIQUE KEYS -> KSDS        */         00005000
                                                                        00005100
    DEFINE ALTERNATEINDEX (                                   -         00005200
                 NAME(JAY01.VSAM.MASTER.AIX)                  -         00005300
                 RELATE(JAY01.VSAM.MASTER)                    -         00005400
                 VOLUMES(PUB000)                              -         00005500
                 RECORDSIZE(480 960)                          -         00005601
                 TRACKS(15 5)                                 -         00005700
                 KEYS(36 149)                                 -         00005801
                 NONUNIQUEKEY                                 -         00005900
                 UPGRADE                                      -         00006000
                 UNIQUE  )                                    -         00006100
           DATA (                                             -         00006200
                 NAME(JAY01.VSAM.MASTER.AIX.DATA) )           -         00006300
           INDEX (                                            -         00006400
                 NAME(JAY01.VSAM.MASTER.AIX.INDEX) )                    00006500
                                                                        00006600
   /* BUILD THE ALTERNATE INDEX FROM THE BASE CLUSTER        */         00006700
                                                                        00006800
    BLDINDEX INDATASET(JAY01.VSAM.MASTER)                     -         00006900
             OUTDATASET(JAY01.VSAM.MASTER.AIX)                          00007000
                                                                        00007100
   /* DELETE PATH, IF IT EXISTS                              */         00007200
                                                                        00007300
    DELETE JAY01.VSAM.MASTER.SORTNAME.IX PATH PURGE                     00007400
                                                                        00007503
    SET LASTCC = 0                                                      00007603
    SET MAXCC = 0                                                       00007703
                                                                        00007800
   /* BUILD THE PATH FOR SORTNAME ACCESS                     */         00007900
                                                                        00008000
    DEFINE PATH (                                             -         00008100
                 NAME(JAY01.VSAM.MASTER.SORTNAME.IX)          -         00008200
                 PATHENTRY(JAY01.VSAM.MASTER.AIX) )                     00008300
                                                                        00008400
/*                                                                      00008500
//                                                                      00008600
./ ADD NAME=JVSRELOD 0101-21356-21356-2328-00065-00086-00008-JAY01   06
//JVSRELOD JOB (1),'RELOAD VSAM',                                       00000101
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * DELETE EXISTING VSAM CLUSTER, DEFINE NEW VSAM CLUSTER, THEN   * * 00000500
//* * LOAD RECORDS FROM SEQUENTIAL BACKUP DATASET AND RECREATE      * * 00000601
//* * ALTERNATE INDEX AND PATH                                      * * 00000701
//* ***************************************************************** * 00000800
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M                                     00000900
//SYSPRINT DD SYSOUT=*                                                  00001000
//BACKUP   DD DISP=OLD,DSN=JAY01.VSAM.MASTER.BACKUP                     00001101
//SYSIN    DD *                                                         00001200
                                                                        00001300
   /* DELETE KSDS CLUSTER AND ASSOCIATED OBJECTS, IF EXISTS  */         00001400
   DELETE JAY01.VSAM.MASTER CLUSTER PURGE                               00001500
                                                                        00001601
   SET LASTCC = 0                                                       00001701
                                                                        00001800
   /* DEFINE KSDS CLUSTER                                    */         00001900
   DEFINE CLUSTER (                                          -          00002000
                NAME(JAY01.VSAM.MASTER)                      -          00002100
                VOLUMES(PUB000)                              -          00002200
                RECORDSIZE(200 200)                          -          00002300
                RECORDS(2600 0)                              -          00002400
                KEYS(07 1)                                   -          00002500
                INDEXED                                      -          00002600
                UNIQUE  )                                    -          00002700
          DATA (                                             -          00002800
                NAME(JAY01.VSAM.MASTER.DATA) )               -          00002900
          INDEX (                                            -          00003000
                NAME(JAY01.VSAM.MASTER.INDEX) )                         00003100
                                                                        00003200
   REPRO INFILE(BACKUP)               -                                 00003301
         OUTDATASET(JAY01.VSAM.MASTER)                                  00003401
                                                                        00003500
   /* DEFINE ALTERNATE INDEX WITH UNIQUE KEYS -> KSDS        */         00003600
                                                                        00003700
    DEFINE ALTERNATEINDEX (                                   -         00003800
                 NAME(JAY01.VSAM.MASTER.AIX)                  -         00003900
                 RELATE(JAY01.VSAM.MASTER)                    -         00004000
                 VOLUMES(PUB000)                              -         00004100
                 RECORDSIZE(480 960)                          -         00004200
                 TRACKS(15 5)                                 -         00004300
                 KEYS(36 149)                                 -         00004400
                 NONUNIQUEKEY                                 -         00004500
                 UPGRADE                                      -         00004600
                 UNIQUE  )                                    -         00004700
           DATA (                                             -         00004800
                 NAME(JAY01.VSAM.MASTER.AIX.DATA) )           -         00004900
           INDEX (                                            -         00005000
                 NAME(JAY01.VSAM.MASTER.AIX.INDEX) )                    00005100
                                                                        00005200
   /* BUILD THE ALTERNATE INDEX FROM THE BASE CLUSTER        */         00005300
                                                                        00005400
    BLDINDEX INDATASET(JAY01.VSAM.MASTER)                     -         00005500
             OUTDATASET(JAY01.VSAM.MASTER.AIX)                          00005600
                                                                        00005700
   /* BUILD THE PATH FOR SORTNAME ACCESS                     */         00005800
                                                                        00005900
    DEFINE PATH (                                             -         00006000
                 NAME(JAY01.VSAM.MASTER.SORTNAME.IX)          -         00006100
                 PATHENTRY(JAY01.VSAM.MASTER.AIX) )                     00006200
                                                                        00006300
/*                                                                      00006400
//                                                                      00006500
./ ADD NAME=JVSREPT1 0101-21356-21356-1222-00013-00013-00006-JAY01   38
//JREPVS1 JOB (1),'VSAM PRI KEY REPORT',                                00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000301
//* ***************************************************************** * 00000401
//* * READ RECORDS SEQUENTIALLY FROM VSAM DATASET IN PRIMARY KEY    * * 00000501
//* * SEQUENCE AND PRODUCE REPORT                                   * * 00000601
//* ***************************************************************** * 00000701
//VSREPT  EXEC PGM=VSREPT,REGION=4M                                     00000801
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00000900
//SYSUDUMP DD SYSOUT=*                                                  00001000
//MASTER   DD DISP=SHR,DSN=JAY01.VSAM.MASTER                            00001100
//REPORT   DD SYSOUT=*                                                  00001200
//                                                                      00001300
./ ADD NAME=JVSREPT2 0100-21356-21356-1222-00013-00013-00000-JAY01   19
//JREPVS2 JOB (1),'VSAM ALT KEY REPORT',                                00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000301
//* ***************************************************************** * 00000401
//* * READ RECORDS SEQUENTIALLY FROM VSAM DATASET IN SECONDARY KEY  * * 00000601
//* * SEQUENCE AND PRODUCE REPORT                                   * * 00000702
//* ***************************************************************** * 00000801
//VSREPT   EXEC PGM=VSREPT,REGION=4M                                    00000900
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001000
//SYSUDUMP DD SYSOUT=*                                                  00001100
//MASTER   DD DISP=SHR,DSN=JAY01.VSAM.MASTER.SORTNAME.IX                00001200
//REPORT   DD SYSOUT=*                                                  00001300
//                                                                      00001400
./ ADD NAME=JVSUNLOD 0101-21356-21356-2322-00019-00086-00006-JAY01   39
//JVSUNLOD JOB (1),'UNLOAD VSAM',                                       00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * COPY RECORDS FROM VSAM CLUSTER TO SEQUENTIAL BACKUP DATASET   * * 00000500
//* ***************************************************************** * 00000600
//IDCAMS  EXEC PGM=IDCAMS,REGION=4M                                     00000700
//SYSPRINT DD SYSOUT=*                                                  00000800
//BACKUP   DD DISP=(NEW,CATLG,DELETE),DSN=JAY01.VSAM.MASTER.BACKUP,     00000901
//            UNIT=SYSDA,VOL=SER=PUB000,                                00001001
//            SPACE=(CYL,(5,5),RLSE),                                   00001101
//            DCB=(RECFM=FB,LRECL=200,BLKSIZE=23400)                    00001201
//SYSIN    DD *                                                         00001300
                                                                        00001400
   REPRO INDATASET(JAY01.VSAM.MASTER)                        -          00001501
         OUTFILE(BACKUP)                                                00001601
                                                                        00001700
/*                                                                      00001800
//                                                                      00001900
./ ADD NAME=JVSUPDT  0100-21356-21356-1625-00036-00036-00000-JAY01   02
//JUPDTVS  JOB (1),'VSAM UPDATE',                                       00000100
//            CLASS=A,MSGCLASS=X,REGION=2M,NOTIFY=&SYSUID               00000200
//*                                                                     00000300
//* ***************************************************************** * 00000400
//* * READ UPDATE RECORDS FROM SEQUENTIAL DATASET (INSTREAM CARDS), * * 00000500
//* * VALIDATE FIELDS, THEN RETRIEVE VSAM RECORDS RANDOMLY AND      * * 00000600
//* * APPLY UPDATES (INCLUDING ADDITION OF RECORDS, CHANGING EXIST- * * 00000700
//* * ING RECORDS, AND DELETING RECORDS)                            * * 00000800
//* ***************************************************************** * 00000900
//VSUPDT   EXEC PGM=VSUPDT,REGION=5M                                    00001000
//STEPLIB  DD DISP=SHR,DSN=JAY01.LOAD                                   00001100
//SYSUDUMP DD SYSOUT=*                                                  00001200
//SYSUT1   DD *                                                         00001300
0007505D                                         :OK                    00001400
0002126U03Stewardson                             :OK                    00001500
0006800A01Bryce                                  :OK                    00001600
0006800A02L                                      :OK                    00001700
0006800A03Williamson                             :OK                    00001800
0006800A044711 ES 18th Street                    :OK                    00001900
0006800A05Marietta, GA 30006                     :OK                    00002000
0006800A06F                                      :OK                    00002100
0006800A077708279615                             :OK                    00002200
0006800A0812132021                               :OK                    00002300
0006800A0910231993                               :OK                    00002400
0006800A1007212003                               :OK                    00002500
0164187U06F                                      :ERR                   00002600
0167576A01Thomas                                 :ERR                   00002700
0159125U074177364870                             :OK                    00002800
0989904D                                         :ERR                   00002900
0851361A01Toni                                   :ERR                   00003000
0851361A03Frain                                  :ERR                   00003100
0990500A01Mark                                   :OK                    00003200
0990500A03Thomas, Jr.                            :OK                    00003300
//MASTER   DD DISP=SHR,DSN=JAY01.VSAM.MASTER                            00003400
//REPORT   DD SYSOUT=*                                                  00003500
//                                                                      00003600
./ ADD NAME=SORTNAME 0104-21348-21348-1035-00078-00045-00000-JAY01   09
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. SORTNAME.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. BUILDS SORT NAME FIELD FROM PASSED FIRST NAME,
000700          LAST NAME, MIDDLE INITIAL.
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER. IBM-370.
001200 OBJECT-COMPUTER. IBM-370.
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500*
001600 DATA DIVISION.
001700 FILE SECTION.
001800*
001900 WORKING-STORAGE SECTION.
002000 01  WS-FIRST-NAME               PIC X(16).
002100 01  FILLER                      REDEFINES WS-FIRST-NAME.
002200     02  WS-FIRST-CHAR           OCCURS 16 TIMES
002300                                 INDEXED BY FN-X
002400                                 PIC X.
002500 01  WS-LAST-NAME                PIC X(21).
002600 01  FILLER                      REDEFINES WS-LAST-NAME.
002700     02  WS-LAST-CHAR            OCCURS 21 TIMES
002800                                 INDEXED BY LN-X
002900                                 PIC X.
003000*
003100 LINKAGE SECTION.
003200 01  FIRST-NAME                  PIC X(15).
003300 01  LAST-NAME                   PIC X(20).
003400 01  MIDDLE-INITIAL              PIC X.
003500 01  SORT-NAME                   PIC X(36).
003600 01  FILLER                      REDEFINES SORT-NAME.
003700     02  SN-CHAR                 OCCURS 36 TIMES
003800                                 INDEXED BY SN-X
003900                                 PIC X.
004000*
004100 PROCEDURE DIVISION USING FIRST-NAME, LAST-NAME,
004200                          MIDDLE-INITIAL, SORT-NAME.
004300*
004400 BUILD-SORT-NAME.
004500*
004600     MOVE FIRST-NAME TO WS-FIRST-NAME.
004700     MOVE LAST-NAME TO WS-LAST-NAME.
004800     MOVE SPACES TO SORT-NAME.
004900     SET LN-X, FN-X, SN-X TO 1.
005000     PERFORM MOVE-LAST-NAME
005100        THRU MOVE-LAST-NAME-EXIT
005200        UNTIL WS-LAST-CHAR (LN-X) = SPACE
005300          AND WS-LAST-CHAR (LN-X + 1) = SPACE.
005400     PERFORM MOVE-FIRST-NAME
005500        THRU MOVE-FIRST-NAME-EXIT
005600        UNTIL WS-FIRST-CHAR (FN-X) = SPACE
005700          AND WS-FIRST-CHAR (FN-X + 1) = SPACE.
005800     MOVE MIDDLE-INITIAL TO SN-CHAR (SN-X).
005900*
006000     GOBACK.
006100*
006200 MOVE-LAST-NAME.
006300*
006400     MOVE WS-LAST-CHAR (LN-X) TO SN-CHAR (SN-X).
006500     SET LN-X, SN-X UP BY 1.
006600*
006700 MOVE-LAST-NAME-EXIT.
006800     EXIT.
006900*
007000 MOVE-FIRST-NAME.
007100*
007200     MOVE WS-FIRST-CHAR (FN-X) TO SN-CHAR (SN-X).
007300     SET FN-X, SN-X UP BY 1.
007400*
007500 MOVE-FIRST-NAME-EXIT.
007600     EXIT.
007700*
007800* END OF PROGRAM SORTNAME.
./ ADD NAME=VSLOAD   0103-21356-21356-1210-00170-00148-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. VSLOAD.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS DATA RECORDS FROM SEQUENTIAL DATASET (TAPE) AND LOADS
000700          VSAM DATASET.
000800*
000900 ENVIRONMENT DIVISION.
001000 CONFIGURATION SECTION.
001100 SOURCE-COMPUTER. IBM-370.
001200 OBJECT-COMPUTER. IBM-370.
001300 INPUT-OUTPUT SECTION.
001400 FILE-CONTROL.
001500*
001600     SELECT SEQUENTIAL-FILE
001700         ASSIGN TO UT-S-SYSUT1.
001800*
001900 DATA DIVISION.
002000 FILE SECTION.
002100*
002200 FD  SEQUENTIAL-FILE
002300     LABEL RECORDS ARE STANDARD
002400     BLOCK CONTAINS 0 RECORDS
002500     DATA RECORD IS SEQUENTIAL-RECD.
002600 01  SEQUENTIAL-RECD.
002700     02  SR-ID                   PIC 9(7).
002800     02  FILLER                  PIC X.
002900     02  SR-FIRST-NAME           PIC X(15).
003000     02  FILLER                  PIC X.
003100     02  SR-INITIAL              PIC X.
003200     02  FILLER                  PIC X.
003300     02  SR-LAST-NAME            PIC X(20).
003400     02  FILLER                  PIC X.
003500     02  SR-STREET               PIC X(35).
003600     02  FILLER                  PIC X.
003700     02  SR-CITY-STATE-ZIP       PIC X(35).
003800     02  FILLER                  PIC X.
003900     02  SR-GENDER-CODE          PIC X.
004000     02  FILLER                  PIC X.
004100     02  SR-TELEPHONE            PIC X(10).
004200     02  FILLER                  PIC X.
004300     02  SR-DATE-1               PIC X(8).
004400     02  FILLER                  PIC X.
004500     02  SR-DATE-2               PIC X(8).
004600     02  FILLER                  PIC X.
004700     02  SR-DATE-3               PIC X(8).
004800     02  FILLER                  PIC X(2).
004900*
005000 WORKING-STORAGE SECTION.
005100 01  SEQUENTIAL-FILE-END-SWITCH  PIC X VALUE 'N'.
005200     88  SEQUENTIAL-FILE-END           VALUE 'Y'.
005300 01  RECORD-COUNTERS             USAGE IS COMP-3.
005400     02  INPUT-RECORD-COUNT      PIC S9(5) VALUE +0.
005500     02  OUTPUT-RECORD-COUNT     PIC S9(5) VALUE +0.
005600 01  COUNTER-EDIT                PIC ZZ,ZZ9.
005700*
005800 01  VSIO-PARAMETER-VALUES       COPY VSAMIO.
005900 01  KSDSF01                     COPY VSAMIOFB.
006000 01  MASTER-RECD.
006100     02  MR-DELETE-CODE          PIC X.
006200     02  MR-ID                   PIC 9(7).
006300     02  MR-FIRST-NAME           PIC X(15).
006400     02  MR-INITIAL              PIC X.
006500     02  MR-LAST-NAME            PIC X(20).
006600     02  MR-STREET               PIC X(35).
006700     02  MR-CITY-STATE-ZIP       PIC X(35).
006800     02  MR-GENDER-CODE          PIC X.
006900     02  MR-TELEPHONE            PIC X(10).
007000     02  MR-DATE-1               PIC X(8).
007100     02  MR-DATE-2               PIC X(8).
007200     02  MR-DATE-3               PIC X(8).
007300     02  MR-SORT-NAME            PIC X(36).
007400     02  FILLER                  PIC X(15).
007500*
007600 PROCEDURE DIVISION.
007700*
007800 OPEN-FILES.
007900*
008000     OPEN INPUT SEQUENTIAL-FILE.
008100*
008200     MOVE 'MASTER' TO VSIO-DDNAME.
008300     MOVE VSIO-KSDS TO VSIO-ORGANIZATION.
008400     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS.
008500     MOVE VSIO-OUTPUT TO VSIO-MODE.
008600     MOVE +200 TO VSIO-RECORD-LENGTH.
008700     MOVE +1 TO VSIO-KEY-POSITION.
008800     MOVE +7 TO VSIO-KEY-LENGTH.
008900     MOVE VSIO-OPEN TO VSIO-COMMAND.
009000     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
009100                         MASTER-RECD.
009200     IF NOT VSIO-SUCCESS
009300         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
009400                 VSIO-COMMAND
009500         EXHIBIT NAMED VSIO-RETURN-CODE,
009600         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
009700                       VSIO-VSAM-FUNCTION-CODE,
009800                       VSIO-VSAM-FEEDBACK-CODE
009900         STOP RUN
010000         .
010100*
010200     PERFORM PROCESS-SEQUENTIAL-FILE
010300        THRU PROCESS-SEQUENTIAL-FILE-EXIT
010400         UNTIL SEQUENTIAL-FILE-END
010500            OR (NOT VSIO-SUCCESS).
010600*
010700     CLOSE SEQUENTIAL-FILE.
010800*
010900     MOVE VSIO-CLOSE TO VSIO-COMMAND.
011000     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
011100                         MASTER-RECD.
011200     IF NOT VSIO-SUCCESS
011300         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
011400                 VSIO-COMMAND
011500         EXHIBIT NAMED VSIO-RETURN-CODE,
011600         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
011700                       VSIO-VSAM-FUNCTION-CODE,
011800                       VSIO-VSAM-FEEDBACK-CODE
011900         STOP RUN
012000     .
012100*
012200     MOVE INPUT-RECORD-COUNT TO COUNTER-EDIT.
012300     DISPLAY COUNTER-EDIT ' RECORDS READ FROM SEQUENTIAL FILE'.
012400     MOVE OUTPUT-RECORD-COUNT TO COUNTER-EDIT.
012500     DISPLAY COUNTER-EDIT ' RECORDS WRITTEN TO VSAM MASTER'.
012600*
012700     GOBACK.
012800*
012900 PROCESS-SEQUENTIAL-FILE.
013000*
013100     READ SEQUENTIAL-FILE
013200         AT END
013300             MOVE 'Y' TO SEQUENTIAL-FILE-END-SWITCH.
013400     IF NOT SEQUENTIAL-FILE-END
013500         ADD 1 TO INPUT-RECORD-COUNT
013600         PERFORM CREATE-VSAM-RECORD
013700            THRU CREATE-VSAM-RECORD-EXIT
013800     .
013900*
014000 PROCESS-SEQUENTIAL-FILE-EXIT.
014100     EXIT.
014200*
014300 CREATE-VSAM-RECORD.
014400*
014500     MOVE SPACES TO MASTER-RECD.
014600     MOVE SR-ID TO MR-ID.
014700     MOVE SR-FIRST-NAME TO MR-FIRST-NAME.
014800     MOVE SR-INITIAL TO MR-INITIAL.
014900     MOVE SR-LAST-NAME TO MR-LAST-NAME.
015000     MOVE SR-STREET TO MR-STREET.
015100     MOVE SR-CITY-STATE-ZIP TO MR-CITY-STATE-ZIP.
015200     MOVE SR-GENDER-CODE TO MR-GENDER-CODE.
015300     MOVE SR-TELEPHONE TO MR-TELEPHONE.
015400     MOVE SR-DATE-1 TO MR-DATE-1.
015500     MOVE SR-DATE-2 TO MR-DATE-2.
015600     MOVE SR-DATE-3 TO MR-DATE-3.
015700     CALL 'SORTNAME' USING SR-FIRST-NAME, SR-LAST-NAME,
015800                           SR-INITIAL, MR-SORT-NAME.
015900*
016000     MOVE VSIO-WRITE TO VSIO-COMMAND.
016100     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
016200                         MASTER-RECD.
016300*
016400     IF VSIO-SUCCESS
016500         ADD +1 TO OUTPUT-RECORD-COUNT.
016600
016700 CREATE-VSAM-RECORD-EXIT.
016800     EXIT.
016900*
017000* END OF PROGRAM VSLOAD.
./ ADD NAME=VSREPT   0104-21356-21356-1236-00222-00187-00000-JAY02   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. VSREPT.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS DATA RECORDS FROM VSAM DATASET AND PRODUCES A SIMPLE
000700          REPORT. SEQUENCE OF REPORT DEPENDS UPON DD USED FOR
000800          MASTER.
000900*
001000 ENVIRONMENT DIVISION.
001100 CONFIGURATION SECTION.
001200 SOURCE-COMPUTER. IBM-370.
001300 OBJECT-COMPUTER. IBM-370.
001400 INPUT-OUTPUT SECTION.
001500 FILE-CONTROL.
001600*
001700     SELECT REPORT-FILE
001800         ASSIGN TO UR-S-REPORT.
001900*
002000 DATA DIVISION.
002100 FILE SECTION.
002200*
002300 FD  REPORT-FILE
002400     LABEL RECORDS ARE OMITTED
002500     BLOCK CONTAINS 0 RECORDS
002600     REPORT IS PRIMARY-KEY-REPORT.
002700*
002800 WORKING-STORAGE SECTION.
002900 01  VSAM-FILE-END-SWITCH        PIC X VALUE 'N'.
003000     88  VSAM-FILE-END                 VALUE 'Y'.
003100 01  RECORD-COUNTERS             USAGE IS COMP-3.
003200     02  INPUT-RECORD-COUNT      PIC S9(5) VALUE +0.
003300*
003400 01  VSIO-PARAMETER-VALUES       COPY VSAMIO.
003500 01  KSDSF01                     COPY VSAMIOFB.
003600 01  MASTER-RECD.
003700     02  MR-DELETE-CODE          PIC X.
003800     02  MR-ID                   PIC 9(7).
003900     02  MR-FIRST-NAME           PIC X(15).
004000     02  MR-INITIAL              PIC X.
004100     02  MR-LAST-NAME            PIC X(20).
004200     02  MR-STREET               PIC X(35).
004300     02  MR-CITY-STATE-ZIP       PIC X(35).
004400     02  MR-GENDER-CODE          PIC X.
004500     02  MR-TELEPHONE            PIC X(10).
004600     02  FILLER                  REDEFINES MR-TELEPHONE.
004700         03  MR-TELEPHONE-A      PIC 9(3).
004800         03  MR-TELEPHONE-P      PIC 9(3).
004900         03  MR-TELEPHONE-N      PIC 9(4).
005000     02  MR-DATE-1               PIC X(8).
005100     02  FILLER                  REDEFINES MR-DATE-1.
005200         03  MR-DATE-1M          PIC 9(2).
005300         03  MR-DATE-1D          PIC 9(2).
005400         03  MR-DATE-1Y          PIC 9(4).
005500     02  MR-DATE-2               PIC X(8).
005600     02  FILLER                  REDEFINES MR-DATE-2.
005700         03  MR-DATE-2M          PIC 9(2).
005800         03  MR-DATE-2D          PIC 9(2).
005900         03  MR-DATE-2Y          PIC 9(4).
006000     02  MR-DATE-3               PIC X(8).
006100     02  FILLER                  REDEFINES MR-DATE-3.
006200         03  MR-DATE-3M          PIC 9(2).
006300         03  MR-DATE-3D          PIC 9(2).
006400         03  MR-DATE-3Y          PIC 9(4).
006500     02  MR-SORT-NAME            PIC X(36).
006600     02  FILLER                  PIC X(15).
006700*
006800 REPORT SECTION.
006900 RD  PRIMARY-KEY-REPORT
007000     CONTROLS IS FINAL
007100     PAGE LIMIT IS 60 LINES
007200     FIRST DETAIL 3
007300     LAST DETAIL 55.
007400*
007500 01  HEADING-ON-PAGE             TYPE IS PAGE HEADING.
007600     02  LINE 1.
007700*
007800 01  RECORD-DETAIL               TYPE IS DETAIL.
007900     02  LINE PLUS 1.
008000         03  COLUMN 01           PIC X
008100                                 SOURCE IS MR-DELETE-CODE.
008200         03  COLUMN 03           PIC 9(7)
008300                                 SOURCE IS MR-ID.
008400         03  COLUMN 11           PIC X(15)
008500                                 SOURCE IS MR-FIRST-NAME.
008600         03  COLUMN 27           PIC X
008700                                 SOURCE IS MR-INITIAL.
008800         03  COLUMN 29           PIC X(20)
008900                                 SOURCE IS MR-LAST-NAME.
009000         03  COLUMN 50           PIC X(35)
009100                                 SOURCE IS MR-STREET.
009200         03  COLUMN 86           PIC X
009300                                 SOURCE IS MR-GENDER-CODE.
009400         03  COLUMN 88           PIC X
009500                                 VALUE '('.
009600         03  COLUMN 89           PIC 9(3)
009700                                 SOURCE IS MR-TELEPHONE-A.
009800         03  COLUMN 92           PIC X
009900                                 VALUE ')'.
010000         03  COLUMN 93           PIC 9(3)
010100                                 SOURCE IS MR-TELEPHONE-P.
010200         03  COLUMN 96           PIC X
010300                                 VALUE '-'.
010400         03  COLUMN 97           PIC 9(4)
010500                                 SOURCE IS MR-TELEPHONE-N.
010600         03  COLUMN 102          PIC 9(2)
010700                                 SOURCE IS MR-DATE-1M.
010800         03  COLUMN 104          PIC X
010900                                 VALUE '/'.
011000         03  COLUMN 105          PIC 9(2)
011100                                 SOURCE IS MR-DATE-1D.
011200         03  COLUMN 107          PIC X
011300                                 VALUE '/'.
011400         03  COLUMN 108          PIC 9(4)
011500                                 SOURCE IS MR-DATE-1Y.
011600         03  COLUMN 113          PIC 9(2)
011700                                 SOURCE IS MR-DATE-2M.
011800         03  COLUMN 115          PIC X
011900                                 VALUE '/'.
012000         03  COLUMN 116          PIC 9(2)
012100                                 SOURCE IS MR-DATE-2D.
012200         03  COLUMN 118          PIC X
012300                                 VALUE '/'.
012400         03  COLUMN 119          PIC 9(4)
012500                                 SOURCE IS MR-DATE-2Y.
012600     02  LINE PLUS 1.
012700         03  COLUMN 11           PIC X(36)
012800                                 SOURCE IS MR-SORT-NAME.
012900         03  COLUMN 50           PIC X(35)
013000                                 SOURCE IS MR-CITY-STATE-ZIP.
013100         03  COLUMN 102          PIC 9(2)
013200                                 SOURCE IS MR-DATE-3M.
013300         03  COLUMN 104          PIC X
013400                                 VALUE '/'.
013500         03  COLUMN 105          PIC 9(2)
013600                                 SOURCE IS MR-DATE-3D.
013700         03  COLUMN 107          PIC X
013800                                 VALUE '/'.
013900         03  COLUMN 108          PIC 9(4)
014000                                 SOURCE IS MR-DATE-3Y.
014100     02  LINE PLUS 1.
014200*
014300 01  REPORT-FOOTING              TYPE IS CONTROL FOOTING FINAL.
014400     02  LINE NEXT PAGE.
014500         03  COLUMN 01           PIC ZZ,ZZ9
014600                                 SOURCE IS INPUT-RECORD-COUNT.
014700         03  COLUMN 08           PIC X(22)
014800                                 VALUE 'RECORDS READ FROM FILE'.
014900*
015000 PROCEDURE DIVISION.
015100*
015200 OPEN-FILES.
015300*
015400     MOVE 'MASTER' TO VSIO-DDNAME.
015500     MOVE VSIO-KSDS TO VSIO-ORGANIZATION.
015600     MOVE VSIO-SEQUENTIAL TO VSIO-ACCESS.
015700     MOVE VSIO-INPUT TO VSIO-MODE.
015800     MOVE +200 TO VSIO-RECORD-LENGTH.
015900     MOVE +1 TO VSIO-KEY-POSITION.
016000     MOVE +7 TO VSIO-KEY-LENGTH.
016100     MOVE VSIO-OPEN TO VSIO-COMMAND.
016200     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
016300                         MASTER-RECD.
016400     IF NOT VSIO-SUCCESS
016500         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
016600                 VSIO-COMMAND
016700         EXHIBIT NAMED VSIO-RETURN-CODE,
016800         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
016900                       VSIO-VSAM-FUNCTION-CODE,
017000                       VSIO-VSAM-FEEDBACK-CODE
017100         STOP RUN
017200     .
017300*
017400     OPEN OUTPUT REPORT-FILE.
017500*
017600     INITIATE PRIMARY-KEY-REPORT.
017700     PERFORM PROCESS-VSAM-MASTER
017800        THRU PROCESS-VSAM-MASTER-EXIT
017900         UNTIL VSAM-FILE-END.
018000     TERMINATE PRIMARY-KEY-REPORT.
018100*
018200     MOVE VSIO-CLOSE TO VSIO-COMMAND.
018300     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
018400                         MASTER-RECD.
018500     IF NOT VSIO-SUCCESS
018600         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
018700                 VSIO-COMMAND
018800         EXHIBIT NAMED VSIO-RETURN-CODE,
018900         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
019000                       VSIO-VSAM-FUNCTION-CODE,
019100                       VSIO-VSAM-FEEDBACK-CODE.
019200     CLOSE REPORT-FILE.
019300*
019400     GOBACK.
019500*
019600 PROCESS-VSAM-MASTER.
019700*
019800     MOVE VSIO-READ TO VSIO-COMMAND.
019900     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
020000                         MASTER-RECD.
020100
020200     IF NOT VSIO-SUCCESS
020300         IF VSIO-END-OF-FILE
020400             MOVE 'Y' TO VSAM-FILE-END-SWITCH
020500         ELSE
020600             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
020700                     VSIO-COMMAND
020800             EXHIBIT NAMED VSIO-RETURN-CODE,
020900             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
021000                           VSIO-VSAM-FUNCTION-CODE,
021100                           VSIO-VSAM-FEEDBACK-CODE
021200             MOVE 'Y' TO VSAM-FILE-END-SWITCH
021300     .
021400     IF NOT VSAM-FILE-END
021500         ADD 1 TO INPUT-RECORD-COUNT
021600         GENERATE RECORD-DETAIL
021700     .
021800*
021900 PROCESS-VSAM-MASTER-EXIT.
022000     EXIT.
022100*
022200* END OF PROGRAM VSREPT.
./ ADD NAME=VSUPDT   0103-21356-21356-2300-00817-00820-00000-JAY01   00
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. VSUPDT.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. DECEMBER, 2021.
000500 DATE-COMPILED.
000600 REMARKS. READS UPDATE INFORMATION FROM SEQUENTIAL DATASET AND UPDATES
000700          VSAM DATASET, WHICH IS ACCESSED RANDOMLY. UPDATES PROCESSED
000800          INCLUDE CHANGING FIELD VALUES OF EXISTING RECORDS, ADDING
000900          NEW RECORDS, AND DELETING RECORDS.
001000*
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER. IBM-370.
001400 OBJECT-COMPUTER. IBM-370.
001500 INPUT-OUTPUT SECTION.
001600 FILE-CONTROL.
001700*
001800     SELECT UPDATE-FILE
001900         ASSIGN TO UT-S-SYSUT1.
002000*
002100     SELECT REPORT-FILE
002200         ASSIGN TO UR-S-REPORT.
002300*
002400 DATA DIVISION.
002500 FILE SECTION.
002600*
002700 FD  UPDATE-FILE
002800     LABEL RECORDS ARE STANDARD
002900     BLOCK CONTAINS 0 RECORDS
003000     RECORD CONTAINS 80 CHARACTERS
003100     DATA RECORD IS UPDATE-RECD.
003200 01  UPDATE-RECD.
003300     02  UPDATE-KEY.
003400         03  UPDATE-ID           PIC X(7).
003500         03  UPDATE-ACTION       PIC X.
003600             88  ACTION-IS-VALID          VALUE 'U' 'A' 'D'.
003700     02  UPDATE-FIELD            PIC X(2).
003800         88  VALID-UPDATE-FIELD           VALUE '01' '02' '03'
003900                                                '04' '05' '06'
004000                                                '07' '08' '09'
004100                                                '10'.
004200         88  UPDATE-FIELD-FIRST-NAME      VALUE '01'.
004300         88  UPDATE-FIELD-INITIAL         VALUE '02'.
004400         88  UPDATE-FIELD-LAST-NAME       VALUE '03'.
004500         88  UPDATE-FIELD-STREET          VALUE '04'.
004600         88  UPDATE-FIELD-CITY            VALUE '05'.
004700         88  UPDATE-FIELD-GENDER          VALUE '06'.
004800         88  UPDATE-FIELD-PHONE           VALUE '07'.
004900         88  UPDATE-FIELD-DATE1           VALUE '08'.
005000         88  UPDATE-FIELD-DATE2           VALUE '09'.
005100         88  UPDATE-FIELD-DATE3           VALUE '10'.
005200     02  UPDATE-DATA                      PIC X(70).
005300     02  UPDATA-DATA-01                   REDEFINES UPDATE-DATA.
005400         03  UPDATE-DATA-FIRST-NAME       PIC X(15).
005500         03  FILLER                       PIC X(55).
005600     02  UPDATA-DATA-02                   REDEFINES UPDATE-DATA.
005700         03  UPDATE-DATA-INITIAL          PIC X.
005800         03  FILLER                       PIC X(69).
005900     02  UPDATA-DATA-03                   REDEFINES UPDATE-DATA.
006000         03  UPDATE-DATA-LAST-NAME        PIC X(20).
006100         03  FILLER                       PIC X(50).
006200     02  UPDATA-DATA-04                   REDEFINES UPDATE-DATA.
006300         03  UPDATE-DATA-STREET           PIC X(35).
006400         03  FILLER                       PIC X(35).
006500     02  UPDATA-DATA-05                   REDEFINES UPDATE-DATA.
006600         03  UPDATE-DATA-CITY             PIC X(35).
006700         03  FILLER                       PIC X(35).
006800     02  UPDATA-DATA-06                   REDEFINES UPDATE-DATA.
006900         03  UPDATE-DATA-GENDER           PIC X.
007000         03  FILLER                       PIC X(69).
007100     02  UPDATA-DATA-07                   REDEFINES UPDATE-DATA.
007200         03  UPDATE-DATA-PHONE            PIC X(10).
007300         03  FILLER                       PIC X(60).
007400     02  UPDATA-DATA-08-10                REDEFINES UPDATE-DATA.
007500         03  UPDATE-DATA-DATE             PIC X(8).
007600         03  FILLER                       PIC X(62).
007700*
007800 FD  REPORT-FILE
007900     LABEL RECORDS ARE OMITTED
008000     REPORT IS UPDATE-REPORT.
008100*
008200 WORKING-STORAGE SECTION.
008300 01  SWITCHES-FOR-TESTS.
008400     02  UPDATE-FILE-END-SWITCH  PIC X VALUE 'N'.
008500         88  UPDATE-FILE-END           VALUE 'Y'.
008600     02  UPDATE-RECORD-VALID-SW  PIC X VALUE 'N'.
008700         88  UPDATE-RECD-VALID         VALUE 'Y'.
008800     02  READ-INVALID-KEY-SW     PIC X VALUE 'N'.
008900         88  READ-INVALID-KEY          VALUE 'Y'.
009000     02  REWRITE-INVALID-KEY-SW  PIC X VALUE 'N'.
009100         88  REWRITE-INVALID-KEY       VALUE 'Y'.
009200     02  WRITE-INVALID-KEY-SW    PIC X VALUE 'N'.
009300         88  WRITE-INVALID-KEY         VALUE 'Y'.
009400*
009500 01  RECORD-COUNTERS             USAGE IS COMP-3.
009600     02  UPDATE-RECORD-COUNT     PIC S9(5) VALUE +0.
009700     02  ERRONEOUS-UPDATE-COUNT  PIC S9(5) VALUE +0.
009800     02  CHANGED-RECORD-COUNT    PIC S9(5) VALUE +0.
009900     02  DELETED-RECORD-COUNT    PIC S9(5) VALUE +0.
010000     02  ADDED-RECORD-COUNT      PIC S9(5) VALUE +0.
010100     02  UNMATCHED-CHANGE-COUNT  PIC S9(5) VALUE +0.
010200     02  DUPLICATE-ADD-COUNT     PIC S9(5) VALUE +0.
010300*
010400 01  WS-UPDATE-RECORD            VALUE LOW-VALUES.
010500     02  WSUR-KEY.
010600         03  WSUR-ID             PIC X(7).
010700         03  WSUR-ACTION         PIC X.
010800             88  ACTION-IS-CHANGE         VALUE 'U'.
010900             88  ACTION-IS-ADD            VALUE 'A'.
011000             88  ACTION-IS-DELETE         VALUE 'D'.
011100     02  WSUR-FIRST-NAME         PIC X(15).
011200     02  WSUR-INITIAL            PIC X.
011300     02  WSUR-LAST-NAME          PIC X(20).
011400     02  WSUR-STREET             PIC X(35).
011500     02  WSUR-CITY               PIC X(35).
011600     02  WSUR-GENDER             PIC X.
011700     02  WSUR-PHONE              PIC X(10).
011800     02  WSUR-DATE1              PIC X(8).
011900     02  WSUR-DATE2              PIC X(8).
012000     02  WSUR-DATE3              PIC X(8).
012100*
012200 01  VSIO-PARAMETER-VALUES       COPY VSAMIO.
012300 01  KSDSF01                     COPY VSAMIOFB.
012400 01  MASTER-RECD.
012500     02  MR-DELETE-CODE          PIC X.
012600     02  MR-ID                   PIC 9(7).
012700     02  MR-FIRST-NAME           PIC X(15).
012800     02  MR-INITIAL              PIC X.
012900     02  MR-LAST-NAME            PIC X(20).
013000     02  MR-STREET               PIC X(35).
013100     02  MR-CITY-STATE-ZIP       PIC X(35).
013200     02  MR-GENDER-CODE          PIC X.
013300     02  MR-TELEPHONE            PIC X(10).
013400     02  FILLER                  REDEFINES MR-TELEPHONE.
013500         03  MR-TELEPHONE-A      PIC 9(3).
013600         03  MR-TELEPHONE-P      PIC 9(3).
013700         03  MR-TELEPHONE-N      PIC 9(4).
013800     02  MR-DATE-1               PIC X(8).
013900     02  FILLER                  REDEFINES MR-DATE-1.
014000         03  MR-DATE-1M          PIC 9(2).
014100         03  MR-DATE-1D          PIC 9(2).
014200         03  MR-DATE-1Y          PIC 9(4).
014300     02  MR-DATE-2               PIC X(8).
014400     02  FILLER                  REDEFINES MR-DATE-2.
014500         03  MR-DATE-2M          PIC 9(2).
014600         03  MR-DATE-2D          PIC 9(2).
014700         03  MR-DATE-2Y          PIC 9(4).
014800     02  MR-DATE-3               PIC X(8).
014900     02  FILLER                  REDEFINES MR-DATE-3.
015000         03  MR-DATE-3M          PIC 9(2).
015100         03  MR-DATE-3D          PIC 9(2).
015200         03  MR-DATE-3Y          PIC 9(4).
015300     02  MR-SORT-NAME            PIC X(36).
015400     02  FILLER                  PIC X(15).
015500*
015600 01  ERROR-MESSAGES.
015700     02  FILLER                  PIC X(50) VALUE
015800         'RECORD ID TO UPDATE NOT NUMERIC'.
015900     02  FILLER                  PIC X(50) VALUE
016000         'UPDATE ACTION NOT VALID (U/A/D)'.
016100     02  FILLER                  PIC X(50) VALUE
016200         'UPDATE FIELD NUMBER NOT VALID (01-10)'.
016300     02  FILLER                  PIC X(50) VALUE
016400         'FIRST NAME MAY NOT BE SPACES'.
016500     02  FILLER                  PIC X(50) VALUE
016600         'LAST NAME MAY NOT BE SPACES'.
016700     02  FILLER                  PIC X(50) VALUE
016800         'STREET MAY NOT BE SPACES'.
016900     02  FILLER                  PIC X(50) VALUE
017000         'CITY, STATE, ZIP MAY NOT BE SPACES'.
017100     02  FILLER                  PIC X(50) VALUE
017200         'GENDER CODE MUST BE "F" OR "M"'.
017300     02  FILLER                  PIC X(50) VALUE
017400         'TELEPHONE NUMBER MUST BE NUMERIC'.
017500     02  FILLER                  PIC X(50) VALUE
017600         'DATE FIELD CONTAINS INVALID CHARACTER'.
017700     02  FILLER                  PIC X(50) VALUE
017800         'YEAR IS NOT VALID FOR DATE'.
017900     02  FILLER                  PIC X(50) VALUE
018000         'MONTH IS NOT VALID FOR DATE'.
018100     02  FILLER                  PIC X(50) VALUE
018200         'DAY IS NOT VALID FOR DATE'.
018300     02  FILLER                  PIC X(50) VALUE
018400         'MASTER RECORD ALREADY EXISTS FOR ADD'.
018500     02  FILLER                  PIC X(50) VALUE
018600         'MASTER RECORD NOT FOUND FOR CHANGE/DELETE'.
018700     02  FILLER                  PIC X(50) VALUE
018800         'INVALID KEY ON REWRITE'.
018900     02  FILLER                  PIC X(50) VALUE
019000         'INVALID KEY ON WRITE'.
019100 01  ERROR-MESSAGE-TABLE         REDEFINES ERROR-MESSAGES.
019200     02  ERROR-MESSAGE-TEXT      OCCURS 17 TIMES
019300                                 INDEXED BY EMX
019400                                 PIC X(50).
019500*
019600 01  DETAIL-TYPES.
019700     02  FILLER                  PIC X(9) VALUE '-BEFORE- '.
019800     02  FILLER                  PIC X(9) VALUE '-AFTER-  '.
019900     02  FILLER                  PIC X(9) VALUE '-ADDED-  '.
020000     02  FILLER                  PIC X(9) VALUE '-DELETED-'.
020100 01  DETAIL-TYPES-TABLE          REDEFINES DETAIL-TYPES.
020200     02  DETAIL-TYPE             OCCURS 4 TIMES
020300                                 INDEXED BY DTX
020400                                 PIC X(9).
020500*
020600 01  GTOA-PARAMETERS.
020700     02   GTOAP-DATE-G           PIC X(8).
020800     02   GTOAP-RETURN-CODE      PIC 9(1).
020900     02   GTOAP-ANUM             PIC S9(7).
021000     02   FILLER                 PIC X(26).
021100*
021200 REPORT SECTION.
021300 RD  UPDATE-REPORT
021400     CONTROLS IS FINAL
021500     PAGE LIMIT IS 60 LINES
021600     FIRST DETAIL 3
021700     LAST DETAIL 55.
021800*
021900 01  HEADING-ON-PAGE             TYPE IS PAGE HEADING.
022000     02  LINE 1.
022100*
022200 01  VALIDATE-ERROR-DETAIL       TYPE IS DETAIL.
022300     02  LINE PLUS 1.
022400         03  COLUMN 01           PIC X(60)
022500                                 SOURCE IS UPDATE-RECD.
022600         03  COLUMN 50           PIC X(50)
022700                                 SOURCE IS
022800             ERROR-MESSAGE-TEXT (EMX).
022900     02  LINE PLUS 1.
023000*
023100 01  RECORD-FIELDS-DETAIL        TYPE IS DETAIL.
023200     02  LINE PLUS 1.
023300         03  COLUMN 01           PIC X
023400                                 SOURCE IS MR-DELETE-CODE.
023500         03  COLUMN 03           PIC 9(7)
023600                                 SOURCE IS MR-ID.
023700         03  COLUMN 11           PIC X(15)
023800                                 SOURCE IS MR-FIRST-NAME.
023900         03  COLUMN 27           PIC X
024000                                 SOURCE IS MR-INITIAL.
024100         03  COLUMN 29           PIC X(20)
024200                                 SOURCE IS MR-LAST-NAME.
024300         03  COLUMN 50           PIC X(35)
024400                                 SOURCE IS MR-STREET.
024500         03  COLUMN 86           PIC X
024600                                 SOURCE IS MR-GENDER-CODE.
024700         03  COLUMN 88           PIC X
024800                                 VALUE '('.
024900         03  COLUMN 89           PIC 9(3)
025000                                 SOURCE IS MR-TELEPHONE-A.
025100         03  COLUMN 92           PIC X
025200                                 VALUE ')'.
025300         03  COLUMN 93           PIC 9(3)
025400                                 SOURCE IS MR-TELEPHONE-P.
025500         03  COLUMN 96           PIC X
025600                                 VALUE '-'.
025700         03  COLUMN 97           PIC 9(4)
025800                                 SOURCE IS MR-TELEPHONE-N.
025900         03  COLUMN 102          PIC 9(2)
026000                                 SOURCE IS MR-DATE-1M.
026100         03  COLUMN 104          PIC X
026200                                 VALUE '/'.
026300         03  COLUMN 105          PIC 9(2)
026400                                 SOURCE IS MR-DATE-1D.
026500         03  COLUMN 107          PIC X
026600                                 VALUE '/'.
026700         03  COLUMN 108          PIC 9(4)
026800                                 SOURCE IS MR-DATE-1Y.
026900         03  COLUMN 113          PIC 9(2)
027000                                 SOURCE IS MR-DATE-2M.
027100         03  COLUMN 115          PIC X
027200                                 VALUE '/'.
027300         03  COLUMN 116          PIC 9(2)
027400                                 SOURCE IS MR-DATE-2D.
027500         03  COLUMN 118          PIC X
027600                                 VALUE '/'.
027700         03  COLUMN 119          PIC 9(4)
027800                                 SOURCE IS MR-DATE-2Y.
027900         03  COLUMN 124          PIC X(9)
028000                                 SOURCE IS DETAIL-TYPE (DTX).
028100     02  LINE PLUS 1.
028200         03  COLUMN 11           PIC X(36)
028300                                 SOURCE IS MR-SORT-NAME.
028400         03  COLUMN 50           PIC X(35)
028500                                 SOURCE IS MR-CITY-STATE-ZIP.
028600         03  COLUMN 102          PIC 9(2)
028700                                 SOURCE IS MR-DATE-3M.
028800         03  COLUMN 104          PIC X
028900                                 VALUE '/'.
029000         03  COLUMN 105          PIC 9(2)
029100                                 SOURCE IS MR-DATE-3D.
029200         03  COLUMN 107          PIC X
029300                                 VALUE '/'.
029400         03  COLUMN 108          PIC 9(4)
029500                                 SOURCE IS MR-DATE-3Y.
029600     02  LINE PLUS 1.
029700*
029800 01  WRITE-ERROR-DETAIL          TYPE IS DETAIL.
029900     02  LINE PLUS 2.
030000         03  COLUMN 01           PIC X(7)
030100                                 SOURCE IS MR-ID.
030200         03  COLUMN 10           PIC X(50)
030300                                 SOURCE IS
030400             ERROR-MESSAGE-TEXT (EMX).
030500     02  LINE PLUS 1.
030600*
030700 01  REPORT-FOOTING              TYPE IS CONTROL FOOTING FINAL.
030800     02  LINE NEXT PAGE.
030900         03  COLUMN 01           PIC ZZ,ZZ9
031000                                 SOURCE IS UPDATE-RECORD-COUNT.
031100         03  COLUMN 08           PIC X(50)
031200                                 VALUE
031300             'UPDATE RECORDS READ'.
031400     02  LINE PLUS 1.
031500         03  COLUMN 01           PIC ZZ,ZZ9
031600                                 SOURCE IS ERRONEOUS-UPDATE-COUNT.
031700         03  COLUMN 08           PIC X(50)
031800                                 VALUE
031900             'UPDATE RECORDS WITH INVALID DATA'.
032000     02  LINE PLUS 2.
032100         03  COLUMN 01           PIC ZZ,ZZ9
032200                                 SOURCE IS CHANGED-RECORD-COUNT.
032300         03  COLUMN 08           PIC X(50)
032400                                 VALUE
032500             'MASTER RECORDS UPDATED'.
032600     02  LINE PLUS 1.
032700         03  COLUMN 01           PIC ZZ,ZZ9
032800                                 SOURCE IS DELETED-RECORD-COUNT.
032900         03  COLUMN 08           PIC X(50)
033000                                 VALUE
033100             'MASTER RECORDS DELETED'.
033200     02  LINE PLUS 1.
033300         03  COLUMN 01           PIC ZZ,ZZ9
033400                                 SOURCE IS ADDED-RECORD-COUNT.
033500         03  COLUMN 08           PIC X(50)
033600                                 VALUE
033700             'MASTER RECORDS ADDED'.
033800     02  LINE PLUS 2.
033900         03  COLUMN 01           PIC ZZ,ZZ9
034000                                 SOURCE IS UNMATCHED-CHANGE-COUNT.
034100         03  COLUMN 08           PIC X(50)
034200                                 VALUE
034300             'ATTEMPTED UPDATES/DELETES WITH NO MATCHING MASTER'.
034400     02  LINE PLUS 1.
034500         03  COLUMN 01           PIC ZZ,ZZ9
034600                                 SOURCE IS DUPLICATE-ADD-COUNT.
034700         03  COLUMN 08           PIC X(50)
034800                                 VALUE
034900             'ATTEMPTED ADDS WITH DUPLICATE MASTER'.
035000*
035100 PROCEDURE DIVISION.
035200*
035300 OPEN-FILES.
035400*
035500     OPEN INPUT UPDATE-FILE,
035600          OUTPUT REPORT-FILE.
035700*
035800     MOVE 'MASTER' TO VSIO-DDNAME.
035900     MOVE VSIO-KSDS TO VSIO-ORGANIZATION.
036000     MOVE VSIO-DIRECT TO VSIO-ACCESS.
036100     MOVE VSIO-INPUT-OUTPUT TO VSIO-MODE.
036200     MOVE +2000 TO VSIO-RECORD-LENGTH.
036300     MOVE +1 TO VSIO-KEY-POSITION.
036400     MOVE +7 TO VSIO-KEY-LENGTH.
036500     MOVE VSIO-OPEN TO VSIO-COMMAND.
036600     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
036700                         MASTER-RECD.
036800     IF NOT VSIO-SUCCESS
036900         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
037000                 VSIO-COMMAND
037100         EXHIBIT NAMED VSIO-RETURN-CODE,
037200         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
037300                       VSIO-VSAM-FUNCTION-CODE,
037400                       VSIO-VSAM-FEEDBACK-CODE
037500         STOP RUN
037600     .
037700*
037800     INITIATE UPDATE-REPORT.
037900     PERFORM PROCESS-UPDATE-FILE
038000        THRU PROCESS-UPDATE-FILE-EXIT
038100         UNTIL UPDATE-FILE-END.
038200     IF WSUR-KEY NOT = LOW-VALUES
038300         PERFORM PROCESS-UPDATE-SET
038400            THRU PROCESS-UPDATE-SET-EXIT.
038500     TERMINATE UPDATE-REPORT.
038600*
038700     MOVE VSIO-CLOSE TO VSIO-COMMAND.
038800     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
038900                         MASTER-RECD.
039000     IF NOT VSIO-SUCCESS
039100         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
039200                 VSIO-COMMAND
039300         EXHIBIT NAMED VSIO-RETURN-CODE,
039400         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
039500                       VSIO-VSAM-FUNCTION-CODE,
039600                       VSIO-VSAM-FEEDBACK-CODE
039700     .
039800*
039900     CLOSE UPDATE-FILE,
040000           REPORT-FILE.
040100*
040200     GOBACK.
040300*
040400 PROCESS-UPDATE-FILE.
040500*
040600     READ UPDATE-FILE
040700         AT END
040800             MOVE 'Y' TO UPDATE-FILE-END-SWITCH
040900     .
041000     IF NOT UPDATE-FILE-END
041100         ADD 1 TO UPDATE-RECORD-COUNT
041200         PERFORM PROCESS-UPDATE-RECORD
041300            THRU PROCESS-UPDATE-RECORD-EXIT
041400     .
041500*
041600 PROCESS-UPDATE-FILE-EXIT.
041700     EXIT.
041800*
041900 PROCESS-UPDATE-RECORD.
042000*
042100     IF WSUR-KEY = LOW-VALUES
042200         MOVE UPDATE-KEY TO WSUR-KEY
042300         MOVE WSUR-ID TO MR-ID
042400         PERFORM READ-VSAM-MASTER
042500            THRU READ-VSAM-MASTER-EXIT
042600     ELSE
042700         IF UPDATE-KEY NOT = WSUR-KEY
042800             PERFORM PROCESS-UPDATE-SET
042900                THRU PROCESS-UPDATE-SET-EXIT
043000             MOVE LOW-VALUES TO WS-UPDATE-RECORD
043100             MOVE UPDATE-KEY TO WSUR-KEY
043200             MOVE WSUR-ID TO MR-ID
043300             PERFORM READ-VSAM-MASTER
043400                THRU READ-VSAM-MASTER-EXIT
043500     .
043600*
043700     MOVE 'Y' TO UPDATE-RECORD-VALID-SW.
043800*
043900     IF UPDATE-ID IS NOT NUMERIC
044000         SET EMX TO 1
044100         GENERATE VALIDATE-ERROR-DETAIL
044200         MOVE 'N' TO UPDATE-RECORD-VALID-SW
044300     .
044400*
044500     IF NOT ACTION-IS-VALID
044600         SET EMX TO 2
044700         GENERATE VALIDATE-ERROR-DETAIL
044800         MOVE 'N' TO UPDATE-RECORD-VALID-SW
044900     .
045000*
045100     IF ACTION-IS-CHANGE
045200     OR ACTION-IS-ADD
045300         IF NOT VALID-UPDATE-FIELD
045400             SET EMX TO 3
045500             GENERATE VALIDATE-ERROR-DETAIL
045600             MOVE 'N' TO UPDATE-RECORD-VALID-SW
045700     .
045800*
045900     IF UPDATE-RECD-VALID AND
046000       (ACTION-IS-CHANGE OR ACTION-IS-ADD)
046100            PERFORM VALIDATE-UPDATE-DATA
046200               THRU VALIDATE-UPDATE-DATA-EXIT
046300     .
046400     IF ACTION-IS-CHANGE
046500     OR ACTION-IS-DELETE
046600         IF READ-INVALID-KEY
046700             SET EMX TO 15
046800             GENERATE VALIDATE-ERROR-DETAIL
046900             ADD 1 TO UNMATCHED-CHANGE-COUNT
047000             MOVE 'N' TO UPDATE-RECORD-VALID-SW
047100         ELSE
047200             NEXT SENTENCE
047300     ELSE
047400         IF NOT READ-INVALID-KEY
047500             SET EMX TO 14
047600             GENERATE VALIDATE-ERROR-DETAIL
047700             ADD 1 TO DUPLICATE-ADD-COUNT
047800             MOVE 'N' TO UPDATE-RECORD-VALID-SW
047900         ELSE
048000             NEXT SENTENCE
048100     .
048200*
048300     IF NOT UPDATE-RECD-VALID
048400         ADD 1 TO ERRONEOUS-UPDATE-COUNT
048500     .
048600*
048700 PROCESS-UPDATE-RECORD-EXIT.
048800     EXIT.
048900*
049000 VALIDATE-UPDATE-DATA.
049100*
049200     IF UPDATE-FIELD-FIRST-NAME
049300         PERFORM VALIDATE-FIRST-NAME
049400            THRU VALIDATE-FIRST-NAME-EXIT
049500     .
049600     IF UPDATE-FIELD-INITIAL
049700         MOVE UPDATE-DATA-INITIAL TO WSUR-INITIAL
049800     .
049900     IF UPDATE-FIELD-LAST-NAME
050000         PERFORM VALIDATE-LAST-NAME
050100            THRU VALIDATE-LAST-NAME-EXIT
050200     .
050300     IF UPDATE-FIELD-STREET
050400         PERFORM VALIDATE-STREET
050500            THRU VALIDATE-STREET-EXIT
050600     .
050700     IF UPDATE-FIELD-CITY
050800         PERFORM VALIDATE-CITY
050900            THRU VALIDATE-CITY-EXIT
051000     .
051100     IF UPDATE-FIELD-GENDER
051200         PERFORM VALIDATE-GENDER
051300            THRU VALIDATE-GENDER-EXIT
051400     .
051500     IF UPDATE-FIELD-PHONE
051600         PERFORM VALIDATE-PHONE
051700            THRU VALIDATE-PHONE-EXIT
051800     .
051900     IF UPDATE-FIELD-DATE1
052000     OR UPDATE-FIELD-DATE2
052100     OR UPDATE-FIELD-DATE3
052200         PERFORM VALIDATE-DATE
052300            THRU VALIDATE-DATE-EXIT
052400     .
052500*
052600 VALIDATE-UPDATE-DATA-EXIT.
052700     EXIT.
052800*
052900 VALIDATE-FIRST-NAME.
053000*
053100     IF UPDATE-DATA-FIRST-NAME = SPACES
053200         SET EMX TO 4
053300         GENERATE VALIDATE-ERROR-DETAIL
053400         MOVE 'N' TO UPDATE-RECORD-VALID-SW
053500     ELSE
053600         MOVE UPDATE-DATA-FIRST-NAME TO WSUR-FIRST-NAME
053700     .
053800*
053900 VALIDATE-FIRST-NAME-EXIT.
054000     EXIT.
054100*
054200 VALIDATE-LAST-NAME.
054300*
054400     IF UPDATE-DATA-LAST-NAME = SPACES
054500         SET EMX TO 5
054600         GENERATE VALIDATE-ERROR-DETAIL
054700         MOVE 'N' TO UPDATE-RECORD-VALID-SW
054800     ELSE
054900         MOVE UPDATE-DATA-LAST-NAME TO WSUR-LAST-NAME
055000     .
055100*
055200 VALIDATE-LAST-NAME-EXIT.
055300     EXIT.
055400*
055500 VALIDATE-STREET.
055600*
055700     IF UPDATE-DATA-STREET = SPACES
055800         SET EMX TO 6
055900         GENERATE VALIDATE-ERROR-DETAIL
056000         MOVE 'N' TO UPDATE-RECORD-VALID-SW
056100     ELSE
056200         MOVE UPDATE-DATA-STREET TO WSUR-STREET
056300     .
056400*
056500 VALIDATE-STREET-EXIT.
056600     EXIT.
056700*
056800 VALIDATE-CITY.
056900*
057000     IF UPDATE-DATA-CITY = SPACES
057100         SET EMX TO 7
057200         GENERATE VALIDATE-ERROR-DETAIL
057300         MOVE 'N' TO UPDATE-RECORD-VALID-SW
057400     ELSE
057500         MOVE UPDATE-DATA-CITY TO WSUR-CITY
057600     .
057700*
057800 VALIDATE-CITY-EXIT.
057900     EXIT.
058000*
058100 VALIDATE-GENDER.
058200*
058300     IF UPDATE-DATA-GENDER = 'M'
058400     OR UPDATE-DATA-GENDER = 'F'
058500         MOVE UPDATE-DATA-GENDER TO WSUR-GENDER
058600     ELSE
058700         SET EMX TO 8
058800         GENERATE VALIDATE-ERROR-DETAIL
058900         MOVE 'N' TO UPDATE-RECORD-VALID-SW
059000     .
059100*
059200 VALIDATE-GENDER-EXIT.
059300     EXIT.
059400*
059500 VALIDATE-PHONE.
059600*
059700     IF UPDATE-DATA-PHONE IS NOT NUMERIC
059800         SET EMX TO 9
059900         GENERATE VALIDATE-ERROR-DETAIL
060000         MOVE 'N' TO UPDATE-RECORD-VALID-SW
060100     ELSE
060200         MOVE UPDATE-DATA-PHONE TO WSUR-PHONE
060300     .
060400*
060500 VALIDATE-PHONE-EXIT.
060600     EXIT.
060700*
060800 VALIDATE-DATE.
060900*
061000     MOVE UPDATE-DATA-DATE TO GTOAP-DATE-G.
061100     CALL 'Y2KGTOA' USING GTOA-PARAMETERS.
061200     IF GTOAP-RETURN-CODE = 2
061300         SET EMX TO 10
061400         GENERATE VALIDATE-ERROR-DETAIL
061500         MOVE 'N' TO UPDATE-RECORD-VALID-SW
061600     .
061700     IF GTOAP-RETURN-CODE = 4
061800         SET EMX TO 11
061900         GENERATE VALIDATE-ERROR-DETAIL
062000         MOVE 'N' TO UPDATE-RECORD-VALID-SW
062100     .
062200     IF GTOAP-RETURN-CODE = 6
062300         SET EMX TO 12
062400         GENERATE VALIDATE-ERROR-DETAIL
062500         MOVE 'N' TO UPDATE-RECORD-VALID-SW
062600     .
062700     IF GTOAP-RETURN-CODE = 8
062800         SET EMX TO 13
062900         GENERATE VALIDATE-ERROR-DETAIL
063000         MOVE 'N' TO UPDATE-RECORD-VALID-SW
063100     .
063200     IF GTOAP-RETURN-CODE = 0
063300     AND UPDATE-FIELD-DATE1
063400         MOVE UPDATE-DATA-DATE TO WSUR-DATE1.
063500     IF GTOAP-RETURN-CODE = 0
063600     AND UPDATE-FIELD-DATE2
063700         MOVE UPDATE-DATA-DATE TO WSUR-DATE2.
063800     IF GTOAP-RETURN-CODE = 0
063900     AND UPDATE-FIELD-DATE3
064000         MOVE UPDATE-DATA-DATE TO WSUR-DATE3.
064100*
064200 VALIDATE-DATE-EXIT.
064300     EXIT.
064400*
064500 PROCESS-UPDATE-SET.
064600*
064700     IF ACTION-IS-CHANGE
064800     OR ACTION-IS-DELETE
064900         IF NOT READ-INVALID-KEY
065000             PERFORM APPLY-UPDATES-TO-MASTER
065100                THRU APPLY-UPDATES-TO-MASTER-EXIT
065200         ELSE
065300             NEXT SENTENCE
065400*            NO ACTION, BECAUSE THIS IS AN ERROR WHICH HAS
065500*            ALREADY BEEN REPORTED
065600     ELSE
065700     IF ACTION-IS-ADD
065800         IF READ-INVALID-KEY
065900             PERFORM ADD-NEW-MASTER
066000                THRU ADD-NEW-MASTER-EXIT
066100         ELSE
066200             NEXT SENTENCE
066300*            NO ACTION, BECAUSE THIS IS AN ERROR WHICH HAS
066400*            ALREADY BEEN REPORTED
066500     .
066600*
066700 PROCESS-UPDATE-SET-EXIT.
066800     EXIT.
066900*
067000 APPLY-UPDATES-TO-MASTER.
067100*
067200     SET DTX TO 1.
067300     GENERATE RECORD-FIELDS-DETAIL.
067400
067500     IF ACTION-IS-DELETE
067600         PERFORM DELETE-VSAM-MASTER-RECORD
067700            THRU DELETE-VSAM-MASTER-RECORD-EXIT
067800     ELSE
067900         PERFORM UPDATE-VSAM-MASTER-FIELDS
068000            THRU UPDATE-VSAM-MASTER-FIELDS-EXIT
068100         SET DTX TO 2
068200         GENERATE RECORD-FIELDS-DETAIL
068300         PERFORM REWRITE-VSAM-MASTER
068400            THRU REWRITE-VSAM-MASTER-EXIT
068500     .
068600*
068700 APPLY-UPDATES-TO-MASTER-EXIT.
068800     EXIT.
068900*
069000 ADD-NEW-MASTER.
069100*
069200     MOVE SPACES TO MASTER-RECD.
069300     MOVE ZEROS TO MR-TELEPHONE, MR-DATE-1,
069400                   MR-DATE-2, MR-DATE-3
069500     MOVE WSUR-ID TO MR-ID
069600     PERFORM UPDATE-VSAM-MASTER-FIELDS
069700        THRU UPDATE-VSAM-MASTER-FIELDS-EXIT.
069800     SET DTX TO 3.
069900     GENERATE RECORD-FIELDS-DETAIL.
070000     PERFORM WRITE-VSAM-MASTER
070100        THRU WRITE-VSAM-MASTER-EXIT.
070200*
070300 ADD-NEW-MASTER-EXIT.
070400     EXIT.
070500*
070600 READ-VSAM-MASTER.
070700*
070800     MOVE 'N' TO READ-INVALID-KEY-SW.
070900     MOVE VSIO-READ TO VSIO-COMMAND.
071000     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
071100                         MASTER-RECD.
071200*
071300     IF NOT VSIO-SUCCESS
071400         IF VSIO-LOGIC-ERROR
071500        AND VSIO-RECORD-NOT-FOUND
071600            MOVE 'Y' TO READ-INVALID-KEY-SW
071700            MOVE LOW-VALUES TO MASTER-RECD
071800         ELSE
071900             DISPLAY 'VSAMIO ERROR OCCURRED DURING '
072000                     VSIO-COMMAND
072100             EXHIBIT NAMED VSIO-RETURN-CODE,
072200             EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
072300                           VSIO-VSAM-FUNCTION-CODE,
072400                           VSIO-VSAM-FEEDBACK-CODE
072500     .
072600*
072700 READ-VSAM-MASTER-EXIT.
072800     EXIT.
072900*
073000 REWRITE-VSAM-MASTER.
073100*
073200     MOVE 'N' TO REWRITE-INVALID-KEY-SW.
073300     MOVE VSIO-REWRITE TO VSIO-COMMAND.
073400     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
073500                         MASTER-RECD.
073600*
073700     IF NOT VSIO-SUCCESS
073800         MOVE 'Y' TO REWRITE-INVALID-KEY-SW
073900         SET EMX TO 16
074000         GENERATE WRITE-ERROR-DETAIL
074100     .
074200     IF NOT REWRITE-INVALID-KEY
074300         ADD 1 TO CHANGED-RECORD-COUNT
074400     .
074500*
074600 REWRITE-VSAM-MASTER-EXIT.
074700     EXIT.
074800*
074900 WRITE-VSAM-MASTER.
075000*
075100     MOVE 'N' TO WRITE-INVALID-KEY-SW.
075200     MOVE VSIO-WRITE TO VSIO-COMMAND.
075300     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
075400                         MASTER-RECD.
075500*
075600     IF NOT VSIO-SUCCESS
075700         MOVE 'Y' TO WRITE-INVALID-KEY-SW
075800         SET EMX TO 17
075900         GENERATE WRITE-ERROR-DETAIL
076000     .
076100     IF NOT WRITE-INVALID-KEY
076200         ADD 1 TO ADDED-RECORD-COUNT
076300     .
076400*
076500 WRITE-VSAM-MASTER-EXIT.
076600     EXIT.
076700*
076800 DELETE-VSAM-MASTER-RECORD.
076900*
077000     MOVE VSIO-DELETE TO VSIO-COMMAND.
077100     CALL 'VSAMIO' USING VSIO-PARAMETER-BLOCK, KSDSF01,
077200                         MASTER-RECD.
077300*
077400     IF VSIO-SUCCESS
077500         ADD 1 TO DELETED-RECORD-COUNT
077600         SET DTX TO 4
077700         GENERATE RECORD-FIELDS-DETAIL
077800     ELSE
077900         DISPLAY 'VSAMIO ERROR OCCURRED DURING '
078000                 VSIO-COMMAND
078100         EXHIBIT NAMED VSIO-RETURN-CODE,
078200         EXHIBIT NAMED VSIO-VSAM-RETURN-CODE,
078300                       VSIO-VSAM-FUNCTION-CODE,
078400                       VSIO-VSAM-FEEDBACK-CODE.
078500*
078600 DELETE-VSAM-MASTER-RECORD-EXIT.
078700     EXIT.
078800*
078900 UPDATE-VSAM-MASTER-FIELDS.
079000*
079100     IF WSUR-FIRST-NAME NOT = LOW-VALUES
079200         MOVE WSUR-FIRST-NAME TO MR-FIRST-NAME.
079300     IF WSUR-INITIAL NOT = LOW-VALUES
079400         MOVE WSUR-INITIAL TO MR-INITIAL.
079500     IF WSUR-LAST-NAME NOT = LOW-VALUES
079600         MOVE WSUR-LAST-NAME TO MR-LAST-NAME.
079700     CALL 'SORTNAME' USING MR-FIRST-NAME, MR-LAST-NAME,
079800                           MR-INITIAL, MR-SORT-NAME.
079900     IF WSUR-STREET NOT = LOW-VALUES
080000         MOVE WSUR-STREET TO MR-STREET.
080100     IF WSUR-CITY NOT = LOW-VALUES
080200         MOVE WSUR-CITY TO MR-CITY-STATE-ZIP.
080300     IF WSUR-GENDER NOT = LOW-VALUES
080400         MOVE WSUR-GENDER TO MR-GENDER-CODE.
080500     IF WSUR-PHONE NOT = LOW-VALUES
080600         MOVE WSUR-PHONE TO MR-TELEPHONE.
080700     IF WSUR-DATE1 NOT = LOW-VALUES
080800         MOVE WSUR-DATE1 TO MR-DATE-1.
080900     IF WSUR-DATE2 NOT = LOW-VALUES
081000         MOVE WSUR-DATE2 TO MR-DATE-2.
081100     IF WSUR-DATE3 NOT = LOW-VALUES
081200         MOVE WSUR-DATE3 TO MR-DATE-3.
081300*
081400 UPDATE-VSAM-MASTER-FIELDS-EXIT.
081500     EXIT.
081600*
081700* END OF PROGRAM VSUPDT.
./ ENDUP       "REVIEW" PDS MEMBER OFFLOAD AT 23:33 ON 21-12-22
><
/*
//